'This program is a simple and intuitive check book program
'written by Charles Dietz.  It is especially useful for tracking
'peronal home acnCounts and reconciling them with bank statements.
'
'checkBook 1.03, Dec 2, 2002
'  - added ESC as toggle between View Mode and Entry Mode
'checkBook 1.04, Dec 7, 2002
'  - added monthly transactions
'  - display [begin bal, end bal] for stmt list
'  - corrected calculator using new sub calculate()
'  - corrected stmt list after saving unfinished reconcile
'  - corrected reconcileDiff while adding entry in reconcile mode
'  - corrected division error in calculator 1-14-03
'checkBook 1.05, May 13, 2004
'  - removed big font
'  - F2 for toggle between register mode and entry mode
'  - F4 for back to main register view (not ESC)
'  - F5 for launching reconcile mode and returning
'  - corrected stmt list sort problem
'  - associated addStmt and editStmt with reconcileMode
'  - corrected problems with group edit
'  - allow changing all but amounts for reconciled entries
'checkBook 1.06, May 26, 2004
'  - completed archive feature
'  - corrected problem with split
'checkBook 1.07, June 1, 2004
'  - process categories from "category.ini" file on file creation
'  - changed category comboboxes to DROPDOWNLIST style (cannot edit)
'  - allow DEL/BACK keys to clear category fields
'  - major changes to allow catg/subcatg name changes
'  - added budget attributes to categories
'checkBook 1.08, July 21, 2004 
'  - added help file 
'  - call enumWindows as a function to enable exit
'  - minor bugs corrected (view menu enabled/grayed)
'  - corrected error selecting one entry
'  - changed monthly entries (adding & removing under view menu) 
'checkBook 1.09, July 21, 2004 
'  - revised TYPE acctData (acctID from 12 to 20 characters)
'  - lengthened acctID textbox in createAcct() and listbox in selectAcct()
'checkBook 1.10, Feb 20, 2006
'  - fixed various bugs related with categories  
'-------------------------------------------------------------------------------
#COMPILE EXE                 
#DIM ALL
'#TOOLS OFF
'#DEBUG ERROR OFF
$VerNo = "1.10"
'#INCLUDE "WIN32API.INC"
'#INCLUDE "ComDlg32.inc"
'#INCLUDE "CommCtrl.inc"
#INCLUDE "CheckBookAPI.inc"
'#INCLUDE "debug.inc"
#INCLUDE "CheckBook.inc"
#INCLUDE "myCalc.inc"
#INCLUDE "myCalendar.inc"
#RESOURCE "CheckBook.pbr"

DECLARE FUNCTION WindowMessage LIB "WINMSG.DLL" ALIAS "WindowMessageA" (BYVAL MsgNum AS LONG) AS STRING
'GLOBAL dbug AS LONG, sbug AS STRING

'-------------------------------------------------------------------------------
'   ** PowerBasic Main **
'-------------------------------------------------------------------------------
FUNCTION PBMAIN()
   LOCAL STYLE AS LONG, s AS STRING, title AS STRING
   LOCAL hMutex AS LONG, prevInstance AS ASCIIZ *64, hWin AS LONG

   'TRACE NEW "trace.bi"
   'TRACE OFF
   'IF LEN(DIR$("log.txt")) THEN KILL "log.txt"
   
   REDIM entry(1:1), payee(1)
   REDIM acct(1:1), acctName(1)
   REDIM catg(1:1), catgName(1)
   REDIM stmt(1:1), memo(1)
   REDIM split(1), tax(1)
   title = "Check Book"
   windowName = title
   ckBookID = "checkBook " + $VerNo 
   prevInstance = ckBookID + " by Charles Dietz"
   hMutex = CreateMutex (BYVAL %NULL, BYVAL %NULL, BYVAL VARPTR(PrevInstance))
   IF ((hMutex <> %NULL) AND (GetLastError = %ERROR_ALREADY_EXISTS)) THEN
      'instance of winPam already running
      IF EnumWindows(CODEPTR(EnumWindowsProc), 0) THEN EXIT FUNCTION
      hWin = FindWindow(BYVAL %NULL, BYVAL VARPTR(windowName))
      ShowWindow hWin, %SW_RESTORE: SetForegroundWindow hWin
      CloseHandle hMutex: EXIT FUNCTION
   END IF
   ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), _
                                0, GetCurrentThreadID)
   STYLE = %WS_SYSMENU OR %WS_MINIMIZEBOX
   dlgHt = 310: dlgWidth = 418
   DIALOG NEW 0, title, , , dlgWidth, dlgHt, STYLE TO hDlg
   DIALOG SET COLOR hDlg, -1, %LTGRAY
   CONTROL ADD TEXTBOX, hDlg, %IDC_kbd, "", 0, 0, 0, 0
   PostMessage hDlg, %WM_USER + 1000, 0, 0
   DIALOG SHOW MODAL hDlg, CALL PBMainProc
END FUNCTION

CALLBACK FUNCTION PBMainProc()
   LOCAL hBit AS LONG, hIcon AS LONG, hInst AS LONG
   LOCAL a AS BYTE, b AS BYTE, i AS LONG, j AS LONG, k AS LONG, q AS QUAD
   LOCAL STYLE AS LONG, style1 AS LONG, style2 AS LONG, sz AS ASCIIZ * 32
   LOCAL xBtn AS LONG, yBtn AS LONG, hKbd AS LONG, yScroll AS LONG, x AS LONG
   LOCAL ti AS STRING, pt AS POINTAPI, ps AS PAINTSTRUCT
   LOCAL m AS LONG, n AS LONG, amt AS LONG, savSelector AS LONG
   LOCAL s AS STRING, ss AS STRING, s1 AS STRING
   LOCAL path AS STRING, f AS STRING, f0 AS STRING, flags AS DWORD
   LOCAL title AS STRING, upper AS STRING, lower AS STRING
   STATIC startIndex AS LONG, hBrush AS LONG, helpFile AS ASCIIZ * 64
   STATIC firstTime AS LONG, xpos AS LONG, ypos AS LONG
   SELECT CASE CBMSG
  'OPEN "log.txt" FOR APPEND AS #1
  'PRINT #1, WindowMessage(CBMSG), TIME$, STR$(CBWPARAM), STR$(CBLPARAM)
  'CLOSE #1
      CASE %WM_INITDIALOG
         helpFile = CURDIR$ + "\Checkbook.hlp" 
         hInst = GetModuleHandle(BYVAL %NULL): hWindow = CBHNDL 
         hIcon = LoadImage(hInst, "ckbkICON", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
         x = GetDeviceCaps(GetDC(CBHNDL), %VERTRES)
         numDisplayed = 20
         regTop = %Top + 25
         regBottom = %Top + 32 + 15 * numDisplayed
         DIALOG PIXELS hDlg, 0, regBottom TO UNITS x, yBottom
         DIALOG PIXELS hDlg, 0, 15*numDisplayed TO UNITS x, yScroll
         xBtn = dlgWidth - 60: yBtn = yBottom + 26
         STYLE = %WS_CHILD OR %WS_VISIBLE OR %SBS_VERT
         CONTROL ADD SCROLLBAR, hDlg, %IDC_SCROLLBAR1, "ScrollBar1",_
                                395, %Top + 18, 12, yScroll+2, STYLE
         CONTROL ADD LABEL, hDlg, %IDC_Memo, "Memo> ", 8, yBottom, 165, 12, , %WS_EX_CLIENTEDGE
         CONTROL ADD LABEL, hDlg, %IDC_Catg, "Catg> ", 173, yBottom, 165, 12, , %WS_EX_CLIENTEDGE
         CONTROL ADD LABEL, hDlg, %IDC_LABEL1, "", 13, %Top+8, 380, 10
         CONTROL ADD LABEL, CBHNDL, %IDC_LABEL2, "", 20, yBtn - 9, 330, 10
         CONTROL ADD LABEL, CBHNDL, %IDC_LABEL3, "", 20, yBtn + 28, 330, 10
         CONTROL SET COLOR CBHNDL, %IDC_LABEL1, RGB(0, 0, 0), %LTGRAY
         CONTROL SET COLOR CBHNDL, %IDC_LABEL2, RGB(0, 0, 128), %LTGRAY
         CONTROL SET COLOR CBHNDL, %IDC_LABEL3, RGB(0, 0, 128), %LTGRAY
         hdc=GetDc(CBHNDL)
         hFont = makeFont(hDC, "MS Sans Serif", 10)       
         ReleaseDC hDlg, hdc
         CONTROL SEND hDlg, %IDC_LABEL1, %WM_SETFONT, hFont, 0 
         CONTROL ADD FRAME, CBHNDL, -1, "", 7, yBtn - 14, 401, 56
         STYLE = %WS_TABSTOP OR %WS_BORDER OR %ES_LEFT: n = 0
         CONTROL ADD TEXTBOX, CBHNDL, %IDC_AddDate, "", 10, yBtn, 37, 13, STYLE, n
         CONTROL ADD TEXTBOX, CBHNDL, %IDC_AddCkNo, "", 47, yBtn, 40, 13, STYLE, n
         style1 = %WS_TABSTOP OR %CBS_DROPDOWN OR %WS_BORDER OR %CBS_SORT OR %WS_VSCROLL
         CONTROL ADD COMBOBOX, CBHNDL, %IDC_AddPayee, , 87, yBtn, 158, 163, style1
         CONTROL ADD TEXTBOX, CBHNDL, %IDC_AddPay, "", 245, yBtn, 48, 13, STYLE, n
         CONTROL ADD TEXTBOX, CBHNDL, %IDC_AddDep, "", 293, yBtn, 48, 13, STYLE, n
         CONTROL ADD TEXTBOX, CBHNDL, %IDC_AddMemo, "", 10, yBtn+14, 137, 13, STYLE, n
         style2 = %WS_TABSTOP OR %CBS_DROPDOWNLIST OR %WS_BORDER OR %CBS_AUTOHSCROLL OR %WS_VSCROLL
         CONTROL ADD COMBOBOX, CBHNDL, %IDC_AddCatg, , 147, yBtn+14, 97, 85, style2
         CONTROL ADD COMBOBOX, CBHNDL, %IDC_AddSubCatg, , 244, yBtn+14, 97, 85, style2
         CONTROL SEND CBHNDL, %IDC_AddCatg, %CB_SETDROPPEDWIDTH, 185, 0
         CONTROL SEND CBHNDL, %IDC_AddSubcatg, %CB_SETDROPPEDWIDTH, 185, 0
         CONTROL SEND CBHNDL, %IDC_AddDate, %EM_SETLIMITTEXT, 8, 0
         CONTROL SEND CBHNDL, %IDC_AddCkNo, %EM_SETLIMITTEXT, 8, 0
         CONTROL SEND CBHNDL, %IDC_AddPay, %EM_SETLIMITTEXT, 10, 0
         CONTROL SEND CBHNDL, %IDC_AddDep, %EM_SETLIMITTEXT, 10, 0
         title = "    Date      CkNo           Payee" + SPACE$(56)_
               + "c          Pay              Dep               Balance"
         upper = "Date         CkNo             Payee" + SPACE$(73) + "Pay                 Dep"
         lower = "  Memo" + SPACE$(60) + "Category" + SPACE$(35) + "Sub category"
         CONTROL SET TEXT hDlg, %IDC_LABEL1, title
         CONTROL SET TEXT hDlg, %IDC_LABEL2, upper
         CONTROL SET TEXT hDlg, %IDC_LABEL3, lower
         'add button controls
         CONTROL ADD BUTTON, CBHNDL, %IDC_EnterBtn, "Add Entry", 344, yBtn+14, 62, 15
         CONTROL ADD BUTTON, CBHNDL, %IDC_NewBtn, "New", 344, yBtn, 30, 13,%BS_CENTER
         CONTROL ADD BUTTON, CBHNDL, %IDC_ChgBtn, "Chg", 376, yBtn, 30, 13,%BS_CENTER
         CONTROL ADD BUTTON, CBHNDL, %IDC_findBtn, "Find", 340, yBottom, 33, 16,%BS_CENTER
         CONTROL ADD BUTTON, CBHNDL, %IDC_QuitBtn, "Quit", 375, yBottom, 33, 16,%BS_CENTER
         AttachMenu: AttachStatusBar:
         CONTROL HANDLE CBHNDL, %IDC_SCROLLBAR1 TO hScrollBar
         CONTROL HANDLE CBHNDL, %IDC_kbd TO hKbd
         gOldKbdProc = SetWindowLong (hKbd, %GWL_WNDPROC, CODEPTR(kbdProc&))
         ghKbdHook = SetWindowsHookEx(%WH_KEYBOARD, CODEPTR(KeyboardHook), _
                                      0, GetCurrentThreadID) 
         entryNo = 0: updateAcct: fontSize = 8
         DIALOG UNITS CBHNDL, dlgWidth, dlgHt TO PIXELS dxpix, dypix
         hdc = GetDC(CBHNDL)
         memdc = CreateCompatibleDC(hdc)
         hBit = CreateCompatibleBitmap(hdc, dxpix, dypix)
         SelectObject memdc, hBit
         hBrush = GetStockObject(%LTGRAY_BRUSH)
         SelectObject memdc, hBrush
         PatBlt memdc, 0, 0, dxpix, dypix, %PATCOPY
         ReleaseDC CBHNDL, hdc
         statusLine 1: statusLine 2
         firstTime = 1
         toggleWindowState
      CASE %WM_USER + 1000  'simulate Alt key for Windows XP
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1 
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1
      CASE %WM_CTLCOLORDLG
         IF reviveMonitor THEN BringWindowToTop CBHNDL
      CASE %WM_CTLCOLORBTN
         IF reviveMonitor THEN reviveMonitor = 0: repaintScrn
      CASE %WM_PAINT
         IF reviveMonitor THEN EXIT FUNCTION
         hdc = BeginPaint(CBHNDL, ps)
         BitBlt hdc, 0, 0, dxpix, dypix, memdc, 0, 0, %SRCCOPY
         EndPaint CBHNDL, ps
         IF firstTime THEN 'open files 
            firstTime = 0: acctOpt = 2: showInit = 1: updateScrn
            origDir = LCASE$(CURDIR$): openIniFile: hWindow = CBHNDL 
            m = LEN(DIR$(LCASE$(thisFile)))
            IF m THEN openTheFile: statusLine 1 ELSE thisFile = ""
            IF archiveFile THEN disableEntryMode 1
            DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_FILE_CHANGEACCT, 0
            IF numCatgs = 0 AND acctNo THEN openCatgFile 
            updateScrn
         END IF
         FUNCTION = 1
      CASE %WM_VSCROLL
         SELECT CASE LOWRD(CBWPARAM)
            CASE %SB_LINEDOWN
               INCR vpos: n = si.nMax - numDisplayed + 1
               IF vpos > n THEN vpos = n: EXIT FUNCTION
            CASE %SB_LINEUP
               vpos = vpos - 1
               IF vpos < si.nMin THEN vpos = si.nMin: EXIT FUNCTION
            CASE %SB_THUMBTRACK
               vpos = HIWRD(CBWPARAM)
            CASE %SB_PAGEDOWN
               n = (si.nMax - si.nMin)\10
               vpos = MIN(vpos + n, si.nMax)
            CASE %SB_PAGEUP
               n = (si.nMax - si.nMin)\10
               vpos = MAX(vpos - n, si.nMin)
         END SELECT
         IF CBLPARAM = hScrollBar THEN
            si.fMask = %SIF_POS: si.nPos = vpos
            SetScrollInfo BYVAL hScrollBar, BYVAL %SB_CTL, si, 1
            topEntry = MAX(vpos, 1): updateScrn
         END IF
      CASE %WM_HELP 'F1 for help
         winHelp CBHNDL, helpFile, 15, 0
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDM_FILE_OPEN
               IF fileChanged THEN
                  s = "File has changed..." + $CRLF + "Save it now?"
                  n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Save File")
                  IF n = %IDYES THEN saveTheFile
               END IF
               DO 'choose file with an acnCount
                  openDialog: IF dlgResult = 2 THEN EXIT FUNCTION
               LOOP UNTIL dlgResult = 0
               prevSelector = 0: showInit = 1
               acctNo = 0: updateAcct: acctOpt = 2: selectAcct 0
               acctNo = selectAcctFcn: stmtNo = 0: acctOpt = 3
               IF acctNo = 0 THEN
                  DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
                  EXIT FUNCTION
               END IF
               updateAcct: showInit = 1: updateScrn 
            CASE %IDM_FILE_SAVE
               n = MSGBOX("Save file now?", %MB_YESNO + %MB_ICONQUESTION, "Save File")
               IF n = %IDYES THEN
                  IF LEN(thisFile) THEN
                     fileChanged = 1: saveTheFile
                  ELSE
                     DIALOG SEND hDlg, %WM_COMMAND, %IDM_FILE_SaveAs, 0
                  END IF
               END IF: EXIT FUNCTION
            CASE %IDM_FILE_SAVEAS
               path = CURDIR$: f = thisFile: f0 = f
               flags = %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY OR %OFN_LONGNAMES
               flags = flags OR %OFN_OVERWRITEPROMPT
               IF ISTRUE (SaveFileDialog(BYVAL hDlg, BYVAL "Save File", f, BYVAL path,_
                  BYVAL "CheckBook Files (*.ckb)|*.ckb|All Files (*.*)|*.*", "ckb", flags)) THEN 
                  thisFile = REMAIN$(LCASE$(f), origDir + "\")
                  fileChanged = 1: saveIniFile: saveTheFile: statusLine 1
               END IF
            CASE %IDM_FILE_PRINT
               printData: updateScrn
            CASE %IDM_FILE_CHANGEACCT
               b = acctNo: selectAcct b
               IF selectAcctFcn THEN acctNo = selectAcctFcn
               IF acctNo AND acctNo <> b THEN
                  IF viewStmtMode THEN 
                     DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_QuitBtn, 0
                  END IF
                  entryNo = 0: viewStmtMode = 0
                  acctOpt = 3: updateAcct
                  UpdateWindow CBHNDL 
                  IF selectAcctFcn THEN lastAcct = b 
               ELSEIF b THEN
                  acctNo = b
               ELSE
                  DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
                  EXIT FUNCTION
               END IF
               hWindow = CBHNDL
               IF lastAcct THEN MENU SET STATE hMenu, BYCMD %IDM_FILE_LASTACCT, %MF_ENABLED
               IF CLEAR THEN DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_NewBtn, 0
            CASE %IDM_FILE_LASTACCT
               IF lastAcct THEN
                  b = acctNo: acctNo = lastAcct: lastAcct = b: viewStmtMode = 0
                  entryNo = 0: acctOpt = 3: updateAcct: hWindow = CBHNDL 
               END IF
            CASE %IDM_FILE_ARCHIVE
               archiveStmts
            CASE %IDM_FILE_EXIT
               DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
            CASE %IDM_EDIT_ADDENTRY
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_EnterBtn, 0
            CASE %IDM_EDIT_NEWENTRY
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_NewBtn, 0
            CASE %IDM_EDIT_DUPENTRY
               IF moEntry = 0 THEN clearEntry 
               IF selector = 0 THEN EXIT FUNCTION
               n = active(selector): getFields n
               IF LEN(lastDate) = 0 THEN
                  s = DATE$
                  lastDate = LEFT$(s, 2) + "/" + MID$(s, 4, 2) +"/" + RIGHT$(s, 2)
               END IF
               IF moEntry THEN
                  s = fields(0): s1 = STR$(storDate(s))
                  m = VAL(MID$(s1, 6, 2)): n = VAL(MID$(s1, 2, 4))
                  INCR m: IF m > 12 THEN m = 1: INCR n
                  MID$(s, 1) = RIGHT$("0" + TRIM$(STR$(m)), 2)
                  fields(0) = LEFT$(s, 6) + RIGHT$(STR$(n), 2)
               ELSE
                  fields(0) = lastDate
               END IF
               IF LEN(fields(1)) THEN
                  fields(1) = TRIM$(STR$(acct(acctNo).lastCkNo + 1))
               END IF
               showEntry: CONTROL SET FOCUS CBHNDL, %IDC_AddDate 
            CASE %IDM_EDIT_MOENTRIES
               IF moEntry THEN moEntry = 0: EXIT SELECT ELSE clearEntry
               addMoEntries: CONTROL SET FOCUS hDlg, %IDC_Kbd: windowNo = 0
            CASE %IDM_EDIT_ADDMOENTRY, %IDM_EDIT_DELMOENTRY
               IF CBCTL = %IDM_EDIT_ADDMOENTRY THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_EDIT_DUPENTRY, 0: n = 1
               END IF
               CONTROL GET TEXT CBHNDL, %IDC_AddPayee TO s: s = UCASE$(s)
               ARRAY SCAN payee(1), COLLATE UCASE, = s, TO i
               moPayee(i) = n: fileChanged = 1: j = numActive
               DO UNTIL j = 0 'scan for last entry with matching monthly payee
                  IF entry(active(j)).payee = i THEN
                     BIT SET entry(active(j)).flag, 1: EXIT DO
                  END IF: DECR j
               LOOP
               clearEntry: CLEAR = 0 
               IF CBCTL = %IDM_EDIT_ADDMOENTRY THEN CONTROL SET FOCUS CBHNDL, %IDC_Kbd
            CASE %IDM_EDIT_VOIDENTRY
               n = active(selector): s = "Void this entry now?"
               IF BIT(entry(n).flag, 4) THEN s = "un" + s
               k = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Void Entry")
               IF k = %IDNO THEN EXIT FUNCTION
               BIT TOGGLE entry(n).flag, 4
               IF BIT(entry(n).flag, 4) THEN
                  acct(acctNo).endbal = acct(acctNo).endbal + entry(n).amt
               ELSE
                  acct(acctNo).endbal = acct(acctNo).endbal - entry(n).amt
               END IF
               entryNo = active(selector): recalcBalances
               updateScrn: clearEntry: fileChanged = 1
            CASE %IDM_EDIT_MOVENTRY
               IF numSelected THEN
                  s = "Move these" + STR$(numSelected) + " entries now?"
               ELSE
                  s = "Move this entry now?"
               END IF
               n = MSGBOX(s, %MB_YESNO + %MB_ICONWARNING, "Move Entry")
               IF n = %IDYES THEN
                  a = acctNo: selectAcct a
                  b = selectAcctFcn
                  IF b = 0 OR b = acctNo THEN EXIT FUNCTION
                  m = selector: j = 1: k = numActive
                  IF numSelected = 0 THEN 
                     j = m: k = j: BIT SET entry(active(j)).flag, 2
                  END IF
                  FOR i = j TO k
                     n = active(i)
                     IF BIT(entry(n).flag, 2) THEN
                        entry(n).acct = b 
                        entryNo = n: DECR numSelected
                        BIT RESET entry(n).flag, 2
                        BIT RESET entry(n).flag, 0
                        acct(a).endBal = acct(a).endBal + entry(n).amt
                        acct(b).endBal = acct(b).endBal - entry(n).amt
                     END IF
                  NEXT i
                  acctNo = b: lastAcct = a: updateAcct: statusLine 1
                  numSelected = 0: amtSelected = 0: fileChanged = 1
                  MENU SET STATE hMenu, BYCMD %IDM_FILE_LASTACCT, %MF_ENABLED
               END IF
            CASE %IDM_EDIT_DELENTRY
               IF numSelected THEN
                  s = "Delete these" + STR$(numSelected) + " entries now?"
               ELSE
                  s = "Delete this entry now?"
               END IF
               n = MSGBOX(s, %MB_YESNO + %MB_ICONWARNING, "Delete Entry")
               IF n = %IDYES THEN
                  m = selector: j = 1: k = numActive
                  IF numSelected = 0 THEN j = m: k = j
                  FOR i = j TO k
                     n = active(i): m = selector
                     IF numSelected = 0 OR BIT(entry(n).flag, 2) THEN
                        BIT SET entry(n).flag, 5
                        acct(acctNo).endBal = acct(acctNo).endBal + entry(n).amt
                     END IF
                  NEXT i
                  updateAcct: selector = MAX(m - 1, 1)
                  numSelected = 0: amtSelected = 0
                  someDeleted = 1: fileChanged = 1
               END IF
            CASE %IDM_EDIT_CHGENTRY
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_ChgBtn, 0
            CASE %IDM_EDIT_CHGGROUP
               groupChg: IF grpFound THEN DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_QuitBtn, 0
            CASE %IDM_EDIT_FINDENTRY 
               IF grpFound THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_QuitBtn, 0
               ELSE
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_FindBtn, 0
               END IF
            CASE %IDM_EDIT_FINDPAYEE
               findPayee: CONTROL SET FOCUS CBHNDL, %IDC_AddPayee
            CASE %IDM_VIEW_ENTRY
               IF windowNo = 0 THEN
                  n = %IDC_AddDate
               ELSEIF windowNo < 10 THEN
                  n = %IDC_Kbd
               END IF
               CONTROL SET FOCUS CBHNDL, n
            CASE %IDM_VIEW_SELECTONE
               n = active(selector)
               BIT TOGGLE entry(n).flag, 2
               amt = entry(n).amt
               IF BIT(entry(n).flag, 2) THEN
                  INCR numSelected: amtSelected = amtSelected + amt
               ELSE
                  DECR numSelected: amtSelected = amtSelected - amt
               END IF
               updateScrn: statusLine 1: setMenuState
            CASE %IDM_VIEW_SELECTALL
               FOR i = 1 TO numActive
                  BIT SET entry(active(i)).flag, 2
                  amtSelected = amtSelected + entry(active(i)).amt
               NEXT i
               numSelected = numActive
               updateScrn: statusLine 1: setMenuState
            CASE %IDM_VIEW_DESELECT
               IF numSelected THEN
                  FOR i = 1 TO numEntries
                     BIT RESET entry(i).flag, 2
                  NEXT i
                  updateScrn: numSelected = 0: amtSelected = 0
                  statusLine 1: setMenuState
               END IF
            CASE %IDM_VIEW_SPLIT
               processSplit
            CASE %IDM_VIEW_QUIT
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_QuitBtn, 0
            CASE %IDM_TASKS_ACCTS
               acctOpt = 1
               DIALOG SEND CBHNDL, %WM_COMMAND, %IDM_FILE_CHANGEACCT, 0
            CASE %IDM_TASKS_STMTS
               listStmts: hWindow = CBHNDL
            CASE %IDM_TASKS_CATGS
               listCatgs: hWindow = CBHNDL 
            CASE %IDM_TASKS_REPORTS
            CASE %IDM_TASKS_CALENDAR
               calendar: hWindow = CBHNDL
            CASE %IDM_TASKS_CALCULATOR
               calculator: hWindow = CBHNDL
            CASE %IDM_REC_BEGIN
               MENU GET TEXT hMenu, BYCMD %IDM_REC_BEGIN TO s
               IF INSTR(s, "Continue") THEN 
                  reconcileMode = 1: getReconcileDiff
                  updateAcct: statusLine 1
               ELSE
                  editStmt = 0: defineStmt: hWindow = CBHNDL
               END IF
            CASE %IDM_REC_CLEARED 'select entries cleared by bank
               IF reconcileMode THEN 'toggle cleared flag
                  amtSelected = 0
                  IF numSelected THEN
                     i = 1: j = numActive
                  ELSE
                     i = selector: j = i
                     selector = MIN(selector + 1, numActive)
                  END IF
                  FOR k = i TO j
                     n = active(k)
                     IF numSelected AND BIT(entry(n).flag, 2) = 0 THEN ITERATE
                     BIT TOGGLE entry(n).flag, 0
                     IF BIT(entry(n).flag, 0) THEN
                        reconcileDiff = reconcileDiff + entry(n).amt
                        IF stmt(stmtNo).date < acct(acctNo).beginDate THEN
                           acct(acctNo).endbal = acct(acctNo).endbal + entry(n).amt
                        END IF
                     ELSE
                        reconcileDiff = reconcileDiff - entry(n).amt
                        IF stmt(stmtNo).date < acct(acctNo).beginDate THEN
                           acct(acctNo).endbal = acct(acctNo).endbal - entry(n).amt
                        END IF
                     END IF
                     BIT RESET entry(n).flag, 2
                  NEXT k
                  numSelected = 0: fileChanged = 1
                  IF selector >= topEntry + numDisplayed THEN
                     topEntry = selector - numDisplayed + 1
                     si.fMask = %SIF_POS: si.nPos = selector - numDisplayed + 1
                     SetScrollInfo BYVAL hScrollBar, BYVAL %SB_CTL, si, 1
                  END IF
                  updateScrn: setMenuState: statusLine 1
                  IF reconcileDiff = 0 THEN 'ok to close statement
                     MENU SET STATE hMenu, BYCMD %IDM_REC_CLOSE, %MF_ENABLED
                     DIALOG SEND hDlg, %WM_COMMAND, %IDM_REC_CLOSE, 0
                  ELSE
                     MENU SET STATE hMenu, BYCMD %IDM_REC_CLOSE, %MF_GRAYED
                  END IF
               END IF
            CASE %IDM_REC_CLOSE
               ti = "Close Statement"
               s = "Do you wish to close statement now?"
               n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, ti)
               IF n = %IDYES THEN
                  stmt(stmtNo).closed = 1
                  FOR i = 1 TO numActive
                     n = active(i)
                     IF BIT(entry(n).flag, 0) THEN entry(n).stmt = stmtNo
                  NEXT i
                  stmtNo = 0: fileChanged = 1: statusLine 1
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_QuitBtn, 0
               END IF
            CASE %IDM_REC_INIT
               defineStmt
            CASE %IDM_REC_SUMMARY
               summary
            CASE %IDM_HELP_HELP
               winHelp CBHNDL, helpFile, 15, 0
               'DIALOG SEND CBHNDL, %WM_HELP, 0, 0
            CASE %IDM_HELP_ABOUT
               about
            CASE %IDC_AddPayee
               IF CBCTLMSG = %CBN_SETFOCUS THEN
                  startIndex = 0
                  comboEdit = 255
               ELSEIF CBCTLMSG = %CBN_KILLFOCUS THEN
                  comboEdit = 0: editCatg = 0
               ELSEIF CBCTLMSG = %CBN_EDITCHANGE THEN
                  IF backSpac THEN EXIT FUNCTION
                  CONTROL GET TEXT CBHNDL, CBCTL TO sz: j = startIndex
                  CONTROL SEND CBHNDL, CBCTL, %CB_FINDSTRING, j, VARPTR(sz) TO j
                  IF j >= 0 THEN
                     startIndex = j
                     CONTROL SEND CBHNDL, CBCTL, %CB_SETCURSEL, j, 0
                     n = -1: SHIFT LEFT n, 16: n = n + LEN(sz)
                     CONTROL SEND CBHNDL, CBCTL, %CB_SETEDITSEL, 0, n
                  END IF
               END IF
            CASE %IDC_addPay
               CONTROL GET TEXT CBHNDL, %IDC_AddDep TO s
               IF LEN(TRIM$(s)) THEN CONTROL SET FOCUS CBHNDL, %IDC_AddDep
            CASE %IDC_addDep
               CONTROL GET TEXT CBHNDL, %IDC_AddPay TO s
               IF LEN(TRIM$(s)) THEN CONTROL SET FOCUS CBHNDL, %IDC_AddMemo
            CASE %IDC_AddCatg  
               IF CBCTLMSG = %CBN_SETFOCUS THEN
                  editCatg = 6
                  CONTROL GET TEXT CBHNDL, %IDC_AddCatg TO s: sz = TRIM$(s)
                  CONTROL GET TEXT CBHNDL, %IDC_AddDep TO s
                  s = TRIM$(s): IF LEN(s) THEN n = 1
                  resetCatgList n, CBHNDL, %IDC_AddCatg
                  CONTROL SEND CBHNDL, %IDC_AddCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO j
                  COMBOBOX SELECT CBHNDL, %IDC_AddCatg, j + 1
               ELSEIF CBCTLMSG = %CBN_SELENDOK THEN
                  CONTROL SEND CBHNDL, %IDC_AddSubcatg, %CB_SETCURSEL, -1, 0
               END IF
            CASE %IDC_AddSubcatg         
               IF CBCTLMSG = %CBN_SETFOCUS THEN
                  editCatg = 7
                  CONTROL GET TEXT CBHNDL, %IDC_AddCatg TO sz
                  CONTROL SEND CBHNDL, %IDC_AddCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO j
                  CONTROL SEND hDlg, %IDC_AddCatg, %CB_GETITEMDATA, j, 0 TO n
                  IF j = 1 THEN 'process split
                     windowNo = 8
                     toggleWindowState: splitOpt = 1: processSplit 
                     CONTROL SET FOCUS CBHNDL, %IDC_EnterBtn 
                  ELSE
                     CONTROL GET TEXT CBHNDL, %IDC_AddSubcatg TO sz
                     resetSubcatgList n, CBHNDL, %IDC_AddSubcatg
                     CONTROL SEND CBHNDL, %IDC_AddSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO j
                     COMBOBOX SELECT CBHNDL, %IDC_AddSubcatg, j + 1
                  END IF
               END IF
            CASE %IDC_EnterBtn
               addEntry: hWindow = CBHNDL 
               IF nextField THEN
                  CONTROL SET FOCUS CBHNDL, nextField
               ELSE
                  CLEAR = 1: DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_NewBtn, 0
               END IF
            CASE %IDC_NewBtn
               windowNo = 1: toggleWindowState
               IF CLEAR THEN 'clear current entry
                  clearEntry: CLEAR = 0: windowNo = 1
                  CONTROL SET FOCUS CBHNDL, %IDC_AddDate 
               ELSEIF moEntry THEN 
                  CONTROL SET TEXT CBHNDL, %IDC_NewBtn, "Skip"
                  CONTROL SET TEXT CBHNDL, %IDC_ChgBtn, "&End"
               ELSE  'add new entry
                  IF LEN(lastDate) = 0 THEN
                     s = DATE$
                     lastDate = LEFT$(s, 2) + "/" + MID$(s, 4, 2) +"/" + RIGHT$(s, 2)
                  END IF
                  IF acctNo THEN n = acct(acctNo).lastCkNo
                  IF n THEN s = TRIM$(STR$(n + 1)) ELSE s = ""
                  CONTROL SET TEXT CBHNDL, %IDC_AddCkNo, s
                  CONTROL SET TEXT CBHNDL, %IDC_AddDate, lastDate
                  CONTROL SEND CBHNDL, %IDC_AddDate, %EM_SETSEL, 0, -1
                  CONTROL SEND CBHNDL, %IDC_AddCkNo, %EM_SETSEL, 0, -1
                  CLEAR = 1: s = "Clear": ss = "Chg": splitStr = ""
                  CONTROL SET TEXT CBHNDL, %IDC_NewBtn, s
                  CONTROL SET TEXT CBHNDL, %IDC_ChgBtn, ss
                  CONTROL SET FOCUS CBHNDL, %IDC_AddDate
               END IF
            CASE %IDC_ChgBtn
               IF moEntry THEN moEntry = 0: EXIT SELECT
               windowNo = 1: toggleWindowState
               IF selector = 0 THEN EXIT FUNCTION
               n = active(selector): editMode = n: getFields n
               CONTROL SET TEXT CBHNDL, %IDC_EnterBtn, "Replace"
               MENU SET TEXT hMenu, BYCMD %IDM_EDIT_ADDENTRY, "Replace Entry" + $TAB + "Ctrl + Enter"
               showEntry: CONTROL SET FOCUS CBHNDL, %IDC_AddDate  
            CASE %IDC_findBtn
               findRecord
               IF dlgResult THEN dlgResult = 0: windowNo = 0: EXIT SELECT 
               entryNo = 0: updateAcct: statusLine 1: setMenuState 
               CLEAR = 1: DIALOG SEND hDlg, %WM_COMMAND, %IDC_NewBtn, 0
               CONTROL SET FOCUS CBHNDL, %IDC_Kbd
            CASE %IDC_QuitBtn
               CONTROL GET TEXT CBHNDL, CBCTL TO s
               IF s = "Back" THEN
                  IF grpFound THEN
                     grpFound = 0: entryNo = active(selector): updateAcct
                     s = "&Find Entries" + $TAB + "Ctrl + F"
                     MENU SET TEXT hMenu, BYCMD %IDM_EDIT_FINDENTRY, s
                  ELSEIF viewStmtMode THEN
                     disableEntryMode 0
                     viewStmtMode = 0: reconcileMode = 0 
                     entryNo = 0: updateAcct: statusLine 1
                  ELSEIF reconcileMode THEN 
                     entryNo = 0: reconcileMode = 0 
                     updateAcct: statusLine 1
                  ELSEIF editStmt THEN
                     editStmt = 0: stmtNo = 0
                     entryNo = 0: updateAcct 
                  END IF
               ELSEIF fileChanged THEN
                  DIALOG SEND CBHNDL, %WM_SYSCOMMAND, %SC_CLOSE, 0
               ELSE
                  s = "Ok to quit program now?"
                  n = MSGBOX(s, %MB_OKCANCEL + %MB_ICONQUESTION, "Quit Program")
                  IF n = %IDOK THEN DIALOG END CBHNDL
               END IF
               CONTROL SET FOCUS CBHNDL, %IDC_Kbd
         END SELECT
         IF windowNo > 10 THEN EXIT FUNCTION
         IF CBCTL >= %IDC_AddDate AND CBCTL <= %IDC_AddSubcatg THEN
            windowNo = CBCTL - %IDC_AddDate + 1
            hWindow = hDlg: enterFieldID = %IDC_EnterBtn
            IF CBCTLMSG = %EN_CHANGE OR CBCTLMSG = %CBN_SELENDOK THEN
               CLEAR = 1: s = "Clear": ss = "Chg": splitStr = ""
               IF moEntry THEN s = "Skip": ss = "End"
               CONTROL SET TEXT CBHNDL, %IDC_NewBtn, s
               CONTROL SET TEXT CBHNDL, %IDC_ChgBtn, ss
            ELSEIF CBCTLMSG = %EN_SETFOCUS OR CBCTLMSG = %CBN_SETFOCUS THEN
               toggleWindowState
            END IF
         ELSEIF CBCTL = %IDC_Kbd AND CBCTLMSG = %EN_SETFOCUS THEN
            windowNo = 0: toggleWindowState: enterFieldID = 0: moEntry = 0
         ELSEIF CBCTL >= %IDC_EnterBtn AND CBCTL <= %IDC_QuitBtn THEN
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         END IF
      CASE %WM_LBUTTONDOWN 
         xpos = LOWRD(CBLPARAM)
         ypos = HIWRD(CBLPARAM)
         n = validMouseRegion(xpos, ypos)
         IF n = 0 THEN EXIT FUNCTION
         m = selector: selector = n + topEntry - 1:
         i = GetKeyState(%VK_SHIFT) AND &H8000
         j = GetKeyState(%VK_CONTROL) AND &H8000
         IF i THEN
            n = selector: IF m > n THEN SWAP m, n
            FOR k = m TO n
               BIT TOGGLE entry(active(k)).flag, 2
            NEXT k
         ELSEIF j THEN
            n = selector: m = n
            BIT TOGGLE entry(active(n)).flag, 2
         END IF
         IF i OR j THEN
            IF m > n THEN SWAP m, n
            FOR k = m TO n
               amt = entry(active(k)).amt
               IF BIT(entry(active(k)).flag, 2) THEN
                  INCR numSelected: amtSelected = amtSelected + amt
               ELSE
                  DECR numSelected: amtSelected = amtSelected - amt
               END IF
            NEXT k
         END IF
         setMenuState 1: updateScrn: statusLine 1
         CONTROL SET FOCUS CBHNDL, %IDC_Kbd
      CASE %WM_RBUTTONDOWN
         STATIC showingPopupMenu AS LONG
         IF moEntry THEN DIALOG SEND CBHNDL, %WM_LBUTTONDOWN, %MK_LBUTTON, CBLPARAM
         pt.x = LOWRD(CBLPARAM)
         pt.y = HIWRD(CBLPARAM)
         n = validMouseRegion(pt.x, pt.y)
         IF n AND NOT showingPopupMenu THEN
            selector = n + topEntry - 1: updateScrn
            m = active(selector): ClientToScreen hDlg, pt: 
            IF viewStmtMode THEN j = %MF_GRAYED ELSE j = %MF_ENABLED
            MENU SET STATE hMouseMenu, 1, j: MENU SET STATE hMouseMenu, 2, j
            j = %MF_ENABLED
            IF entry(m).stmt OR reconcileMode OR viewStmtMode THEN j = %MF_GRAYED
            MENU SET STATE hMouseMenu, 3, j: MENU SET STATE hMouseMenu, 4, j
            IF BIT(entry(m).flag, 7) THEN j = %MF_ENABLED ELSE j = %MF_GRAYED
            MENU SET STATE hMouseMenu, 7, j
            IF reconcileMode OR viewStmtMode THEN j = %MF_GRAYED ELSE j = %MF_ENABLED
            MENU SET STATE hMouseMenu, 8, j
            IF viewMoEntries OR viewStmtMode THEN j = %MF_GRAYED ELSE j = %MF_ENABLED
            MENU SET STATE hMouseMenu, 6, j
            showingPopupMenu = -1
            TrackPopupMenuEx (hMouseMenu, %TPM_LEFTALIGN, pt.x, pt.y, hDlg, BYVAL %NULL)
            showingPopupMenu = 0
         END IF
      CASE %WM_SYSCOMMAND
         IF CBWPARAM = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow CBHNDL
         ELSEIF CBWPARAM = %SC_CLOSE THEN
            FUNCTION = quitProgram
         END IF
      CASE %WM_DESTROY
         moEntry = 0
         winHelp CBHNDL, helpFile, %HELP_QUIT, 0
         ReleaseDC hDlg, memdc
         DeleteObject hBit
         DeleteObject hBrush
         UnhookWindowsHookEx ghKbdHook
   END SELECT
END FUNCTION

FUNCTION EnumWindowsProc(BYVAL hWnd AS LONG, BYVAL lParam AS LONG) AS LONG
  LOCAL zTxt AS ASCIIZ * 260
  GetWindowText hWnd, zTxt, 260
  IF LEN(zTxt) THEN
     IF LEFT$(zTxt, 10) = "Check Book" THEN
        windowName = zTxt: EXIT FUNCTION
     END IF
  END IF
  FUNCTION = 1
END FUNCTION

FUNCTION kbdProc(BYVAL h&, BYVAL wMsg&, BYVAL wParm&, BYVAL lParm&) AS LONG
   'trap keyboard navigation keys
   LOCAL i AS INTEGER, j AS INTEGER
   LOCAL k AS LONG, m AS LONG, n AS LONG, amt AS LONG, jump AS LONG
   SELECT CASE wMsg&
      CASE %WM_KEYDOWN
         IF viewMoEntries = 0 THEN
            i = GetKeyState(%VK_SHIFT) AND &H8000
            j = GetKeyState(%VK_CONTROL) AND &H8000 
         END IF
         m = selector
         SELECT CASE wParm&
            CASE %VK_UP
               n = selector
               IF n > 1 AND BIT(entry(active(n)).flag, 2) = 0 THEN DECR n
               IF i OR j THEN
                  IF BIT(entry(active(n)).flag, 2) = 0 THEN n = m
                  BIT TOGGLE entry(active(n)).flag, 2: m = n
               END IF
               IF n > 1 AND n = selector THEN DECR selector ELSE selector = n
            CASE %VK_DOWN
               n = selector
               IF i OR j THEN
                  IF BIT(entry(active(n)).flag, 2) = 0 THEN n = m
                  BIT TOGGLE entry(active(n)).flag, 2: m = n
               END IF
               IF selector < numActive THEN INCR selector
            CASE %VK_PGUP
               IF selector > 1 THEN
                  jump = MAX(numDisplayed, numActive/10)
                  selector = MAX(selector - jump, 1)
               END IF
               IF i OR j THEN
                  n = selector
                  IF selector > 1 THEN INCR n
                  FOR k = m TO n STEP -1
                     BIT TOGGLE entry(active(k)).flag, 2
                  NEXT k
               END IF
            CASE %VK_PGDN
               IF selector < numActive THEN
                  jump = MAX(numDisplayed, numActive/10)
                  selector = MIN(selector + jump, numActive)
               END IF
               IF i OR j THEN
                  n = selector
                  IF selector < numActive THEN DECR n
                  FOR k = m TO n
                     BIT TOGGLE entry(active(k)).flag, 2
                  NEXT i
               END IF
            CASE %VK_HOME
               selector = 1
               IF i OR j THEN
                  FOR k = 1 TO m
                     BIT TOGGLE entry(active(k)).flag, 2
                  NEXT i: n = 1
               END IF
            CASE %VK_END
               selector = numActive
               IF i OR j THEN
                  FOR k = m TO numActive
                     BIT TOGGLE entry(active(k)).flag, 2
                  NEXT i: n = numActive
               END IF
            CASE ELSE
               EXIT FUNCTION
         END SELECT
         'update topEntry if necessary
         IF selector >= topEntry + numDisplayed THEN
            topEntry = selector - numDisplayed + 1
            si.fMask = %SIF_POS: si.nPos = selector - numDisplayed + 1
            SetScrollInfo BYVAL hScrollBar, BYVAL %SB_CTL, si, 1
         ELSEIF selector < topEntry THEN
            topEntry = Selector
            si.fMask = %SIF_POS: si.nPos = selector
            SetScrollInfo BYVAL hScrollBar, BYVAL %SB_CTL, si, 1
         END IF
         updateScrn
         IF i OR j THEN
            IF m > n THEN SWAP m, n
            FOR k = m TO n
               amt = entry(active(k)).amt
               IF BIT(entry(active(k)).flag, 2) THEN
                  INCR numSelected: amtSelected = amtSelected + amt
               ELSE
                  DECR numSelected: amtSelected = amtSelected - amt
               END IF
            NEXT i
            statusLine 1
         END IF
         setMenuState 1
   END SELECT
   FUNCTION = callWindowProc(gOldKbdProc, h&, wMsg&, wParm&, lParm&)
END FUNCTION

FUNCTION KeyboardHook(BYVAL iCode AS INTEGER, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS DWORD
   LOCAL s AS STRING, n AS LONG, i AS LONG, j AS LONG
   LOCAL ctrl AS LONG
   STATIC nCount AS LONG
   IF iCode < 0 THEN
      FUNCTION = CallNextHookEx(ghKbdHook, iCode, wParam, lParam)
      EXIT FUNCTION
   END IF
   IF iCode <> %HC_ACTION THEN EXIT FUNCTION
   INCR nCount: IF nCount MOD 2 = 0 THEN nCount = 0: EXIT FUNCTION
   IF windowNo < 10 THEN ctrl = GetKeyState(%VK_CONTROL) AND &H8000
   backSpac = 0
   SELECT CASE wParam
   CASE %VK_RETURN
      IF windowNo THEN 'defining an entry, acct, stmt, or catg
         n = GetDlgCtrlID(GetFocus)
         IF n = 2 OR n = %IDCANCEL THEN 
            EXIT FUNCTION
         ELSEIF ctrl OR n = enterFieldID THEN 
            IF enterFieldID = %IDC_EnterBtn THEN userPrompt = 1
            CONTROL SEND hWindow, n, %BM_SETSTYLE, 0, %TRUE
            DIALOG SEND hWindow, %WM_COMMAND, enterFieldID, 0
         ELSE
            IF windowNo = 8 AND getActiveWindow = hSplit THEN EXIT FUNCTION 
            IF windowNo = 3 THEN payeeSupplement
            SetFocus GetNextDlgTabItem(hWindow, GetFocus, %FALSE)
            n = GetDlgCtrlID(GetFocus)
            IF n = enterFieldID THEN
               CONTROL SEND hWindow, n, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
               FUNCTION = 1
            END IF
            CONTROL SEND hDlg, n, %EM_SETSEL, 0, -1
         END IF
      END IF
   CASE %VK_F2
      IF windowNo THEN
         CONTROL SET FOCUS hDlg, %IDC_Kbd: windowNo = 0
      ELSEIF viewStmtMode = 0 AND archiveFile = 0 THEN
         CONTROL SET FOCUS hDlg, %IDC_AddDate
      END IF
   CASE %VK_F3 'find entry (alternate)
      DIALOG SEND hDlg, %WM_COMMAND, %IDC_findBtn, 0
   CASE %VK_F4 'quit program or back to register
      DIALOG SEND hDlg, %WM_COMMAND, %IDC_QuitBtn, 0 
   CASE %VK_F5 'begin reconcile
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_REC_BEGIN, 0
   CASE %VK_F11 'show calendar
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_TASKS_CALENDAR, 0
   CASE %VK_F12 'show computer
      DIALOG SEND hDlg, %WM_COMMAND, %IDM_TASKS_CALCULATOR, 0
   CASE %VK_BACK, %VK_DELETE
      IF comboEdit THEN
         CONTROL GET TEXT hDlg, %IDC_AddPayee TO s
         CONTROL SEND hDlg, %IDC_AddPayee, %CB_GETEDITSEL, 0, 0 TO n
         i = LOWRD(n): j = HIWRD(n)
         IF i <> j THEN
            s = LEFT$(s, i) + MID$(s, j + 1): backSpac = 1
            CONTROL SET TEXT hDlg, %IDC_AddPayee, s
            n = -1: SHIFT LEFT n, 16: n = n + LEN(s)
            CONTROL SEND hDlg, %IDC_AddPayee, %CB_SETEDITSEL, 0, n
         END IF
      ELSEIF editCatg THEN
         COMBOBOX SELECT hDlg, %IDC_AddDate + editCatg, 0
      END IF
   CASE %VK_A 'select all
      IF ctrl AND windowNo = 0 THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_VIEW_SELECTALL, 0
   CASE %VK_B 'back to register mode
      IF ctrl AND back THEN DIALOG SEND hDlg, %WM_COMMAND, %IDC_QuitBtn, 0
   CASE %VK_C
      IF reconcileMode AND windowNo = 0 THEN 'cleared entry by bank
         DIALOG SEND hDlg, %WM_COMMAND, %IDM_REC_CLEARED, 0
      ELSEIF ctrl AND windowNo = 0 THEN 'change entry
         DIALOG SEND hDlg, %WM_COMMAND, %IDC_ChgBtn, 0
      END IF
   CASE %VK_D 'duplicate entry
      IF windowNo = 0 THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_EDIT_DUPENTRY, 0
   CASE %VK_F 'find entry
      IF ctrl THEN DIALOG SEND hDlg, %WM_COMMAND, %IDC_findBtn, 0
   CASE %VK_L 'toggle last acnCount
      IF ctrl THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_FILE_LASTACCT, 0
   CASE %VK_N 'new transaction
      IF ctrl AND CLEAR = 0 THEN DIALOG SEND hDlg, %WM_COMMAND, %IDC_NewBtn, 0 
   CASE %VK_P 'find payees
      IF ctrl THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_EDIT_FINDPAYEE, 0
   CASE %VK_Q 'quit program
      IF ctrl AND back = 0 THEN DIALOG SEND hDlg, %WM_COMMAND, %IDC_QuitBtn, 0
   CASE %VK_R 'begin reconcile
      IF ctrl THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_REC_BEGIN, 0
   CASE %VK_S 'show split
      IF windowNo = 0 AND BIT(entry(active(selector)).flag, 7) THEN processSplit
   CASE %VK_ESCAPE
      IF hWindow <> hDlg THEN
         DIALOG END hWindow: hWindow = hDlg
      ELSEIF windowNo = 0 THEN
         IF numSelected THEN DIALOG SEND hDlg, %WM_COMMAND, %IDM_VIEW_DESELECT, 0
      ELSEIF windowNo < 10 THEN
         CLEAR = 1: DIALOG SEND hDlg, %WM_COMMAND, %IDC_NewBtn, 0
      END IF
   END SELECT
END FUNCTION

FUNCTION clearedEntry() AS BYTE
   'check if any selected entries are reconciled or cleared
   LOCAL i AS LONG, n AS WORD
   'IF numSelected = 0 THEN EXIT FUNCTION
   FOR i = 1 TO numActive
      n = active(i)
      IF (BIT(entry(n).flag, 2) OR i = selector) AND BIT(entry(n).flag, 0) THEN 'entry(n).stmt THEN
         FUNCTION = 1: EXIT FOR
      END IF
   NEXT i
END FUNCTION

FUNCTION validMouseRegion(x AS LONG, y AS LONG) AS LONG
   'validate mouse click location... make sure its in register region
   'return line number from 1 to numDisplayed
   LOCAL n AS LONG
   IF x < 20 OR y > 568 THEN EXIT FUNCTION
   IF y < %Top + 26 THEN EXIT FUNCTION
   IF y > %Top + 340 THEN EXIT FUNCTION
   n = (y - %Top - 11) \ 15
   IF n < 1 THEN n = 1
   IF n > numActive THEN EXIT FUNCTION
   IF n > numDisplayed THEN n = numDisplayed
   FUNCTION = n
END FUNCTION

SUB clearEntry
   LOCAL i AS LONG, s AS STRING 
   FOR i = 0 TO 7
      IF i >= 6 THEN
         CONTROL SEND hDlg, %IDC_AddDate + i, %CB_SETCURSEL, -1, 0
      ELSE
         CONTROL SET TEXT hDlg, %IDC_AddDate + i, ""
      END IF
   NEXT i
   CONTROL SET TEXT hDlg, %IDC_NewBtn, "New"
   CONTROL SET TEXT hDlg, %IDC_EnterBtn, "Add Entry"
   MENU SET TEXT hMenu, BYCMD %IDM_EDIT_ADDENTRY, "Add Entry" + $TAB + "Ctrl + Enter"
   CONTROL SET FOCUS hDlg, %IDC_AddDate
   splitStr = "": editMode = 0
   IF moEntry THEN moEntry = 2
END SUB

SUB payeeSupplement
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   LOCAL s AS STRING, s1 AS STRING, s2 AS STRING
   CONTROL GET TEXT hDlg, %IDC_AddPayee TO s
   IF LEN(s) = 0 OR numPayees = 0 THEN EXIT SUB
   ARRAY SCAN payee(), COLLATE UCASE, = UCASE$(s), TO n: DECR n
   IF n = 0 THEN EXIT SUB
   FOR i = numActive TO 1 STEP -1
      j = active(i)
      IF entry(j).payee = n THEN m = j: EXIT FOR
   NEXT i
   'Now automatically show last amount if none is defined yet
   CONTROL GET TEXT hDlg, %IDC_AddPay TO s1
   CONTROL GET TEXT hDlg, %IDC_AddDep TO s2
   IF LEN(s1) OR LEN(s2) THEN m = 0 'amt already defined
   IF m THEN
      getFields m
      FOR i = 3 TO 4
         CONTROL SET TEXT hDlg, %IDC_AddDate + i, fields(i)
      NEXT i
   END IF
   CONTROL SET FOCUS hDlg, %IDC_AddPayee
END SUB

SUB AttachMenu
   LOCAL s AS STRING, hPopUp1 AS DWORD, hPopUp2 AS DWORD
   MENU NEW BAR TO hMenu
   MENU NEW POPUP TO hPopUp1
   MENU ADD POPUP, hMenu, "&File", hPopUp1, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Open", %IDM_FILE_OPEN, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Save", %IDM_FILE_SAVE, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "Save &As", %IDM_FILE_SAVEAS, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Print Entries", %IDM_FILE_PRINT, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Change Acct", %IDM_FILE_CHANGEACCT, %MF_ENABLED
      s = "&Last Acct" + $TAB + "Ctrl + L"
      MENU ADD STRING, hPopUp1, s, %IDM_FILE_LASTACCT, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "A&rchive", %IDM_FILE_ARCHIVE, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      s = "E&xit" + $TAB + "Alt + F4"
      MENU ADD STRING, hPopUp1, s, %IDM_FILE_EXIT, %MF_ENABLED
   MENU NEW POPUP TO hPopUp1: hEditMenu = hPopUp1
   MENU NEW POPUP TO hPopUp2
   MENU ADD POPUP, hMenu, "&Edit", hPopUp1, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Add Entry" + $TAB + "Ctrl + Enter", %IDM_EDIT_ADDENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&New Entry"  + $TAB + "Ctrl + N", %IDM_EDIT_NEWENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Change Entry" + $TAB + "Ctrl + C", %IDM_EDIT_CHGENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Duplicate Entry" + $TAB + "Ctrl + D", _
                       %IDM_EDIT_DUPENTRY, %MF_ENABLED
      MENU ADD POPUP, hPopUp1, "&Monthly Entries", hPopUp2, %MF_ENABLED
      'monthly entries popup menu ------------------------------------------------
      MENU ADD STRING, hPopUp2, "&Enter now", %IDM_EDIT_MOENTRIES, %MF_ENABLED
      MENU ADD STRING, hPopUp2, "&Add to", %IDM_EDIT_ADDMOENTRY, %MF_ENABLED 
      MENU ADD STRING, hPopUp2, "&Remove from", %IDM_EDIT_DELMOENTRY, %MF_GRAYED
      '---------------------------------------------------------------------------
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "M&ove Entries", %IDM_EDIT_MOVENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "D&elete Entries", %IDM_EDIT_DELENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Void Entry", %IDM_EDIT_VOIDENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "Change &Group", %IDM_EDIT_CHGGROUP, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Find Entries" + $TAB + "Ctrl + F", %IDM_EDIT_FINDENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Find Payees" + $TAB + "Ctrl + P", %IDM_EDIT_FINDPAYEE, %MF_ENABLED
   MENU NEW POPUP TO hPopUp1
   MENU ADD POPUP, hMenu, "&View", hPopUp1, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Entry Mode", %IDM_VIEW_ENTRY, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "Select &One", %IDM_VIEW_SELECTONE, %MF_GRAYED
      s = "&Select All Shown" + $TAB + "Ctrl + A"
      MENU ADD STRING, hPopUp1, s, %IDM_VIEW_SELECTALL, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "&Deselect All" + $TAB + "ESC", %IDM_VIEW_DESELECT, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Split Transaction", %IDM_VIEW_SPLIT, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "&Quit Program" + $TAB + "F4", %IDM_VIEW_QUIT, %MF_ENABLED
   MENU NEW POPUP TO hPopUp1
   MENU ADD POPUP, hMenu, "&Tasks", hPopUp1, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "List of &AcnCounts", %IDM_TASKS_ACCTS, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "List of &Statements", %IDM_TASKS_STMTS, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "List of &Categories", %IDM_TASKS_CATGS, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Reports", %IDM_TASKS_REPORTS, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "Calen&dar" + $TAB + "F11", _
                                %IDM_TASKS_CALENDAR, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "Calc&ulator" + $TAB + "F12", _
                                %IDM_TASKS_CALCULATOR, %MF_ENABLED
   MENU NEW POPUP TO hPopUp1
   MENU ADD POPUP, hMenu, "&Reconcile", hPopUp1, %MF_ENABLED
      s = "&Begin" + $TAB + "F5"
      MENU ADD STRING, hPopUp1, s, %IDM_REC_BEGIN, %MF_ENABLED
      s = "Clea&red" + $TAB + "C"
      MENU ADD STRING, hPopUp1, s, %IDM_REC_CLEARED, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "Cl&ose", %IDM_REC_CLOSE, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "-", 0, 0
      MENU ADD STRING, hPopUp1, "&Initialize", %IDM_REC_INIT, %MF_GRAYED
      MENU ADD STRING, hPopUp1, "&Summary", %IDM_REC_SUMMARY, %MF_GRAYED
   MENU NEW POPUP TO hPopUp1
   MENU ADD POPUP, hMenu, "&Help", hPopUp1, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&Help" + $TAB + "F1", %IDM_HELP_HELP, %MF_ENABLED
      MENU ADD STRING, hPopUp1, "&About", %IDM_HELP_ABOUT, %MF_ENABLED
   MENU ATTACH hMenu, hDlg

   MENU NEW POPUP TO hMouseMenu '-----------------------------------
   MENU ADD STRING, hMouseMenu, "Duplicate", %IDM_EDIT_DUPENTRY, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Change", %IDM_EDIT_CHGENTRY, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Delete", %IDM_EDIT_DELENTRY, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Void", %IDM_EDIT_VOIDENTRY, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "-", 0, 0
   MENU ADD STRING, hMouseMenu, "Select", %IDM_VIEW_SELECTONE, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Split", %IDM_VIEW_SPLIT, %MF_ENABLED
   MENU ADD STRING, hMouseMenu, "Statement", %IDM_TASKS_STMTS, %MF_ENABLED
END SUB

SUB AttachStatusBar
    hStatus=CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, _
                                BYVAL(%NULL), hDlg, 700)
    DIM sbParts(2) AS LONG
    sbParts(0) = 300
    sbParts(1) = 540
    sbParts(2) = -1  ' sets last one to right edge
    SendMessage hStatus, %SB_SETPARTS,3,BYVAL VARPTR(sbParts(0))
END SUB

SUB statusLine(pane AS LONG)
   LOCAL m AS LONG, n AS LONG, s AS STRING, ti AS STRING
   SELECT CASE pane
      CASE 1
         IF numSelected THEN
            IF viewMoEntries THEN 
               s = "Monthly transactions: "
               s = s + TRIM$(STR$(numSelected)) + " selected entries"
            ELSE
               s = FORMAT$(-amtSelected/100, "#0.00")
               s = TRIM$(STR$(numSelected)) + " selected entries: " + s 
            END IF
         ELSEIF reconcileMode THEN 
            IF reconcileDiff = 0 AND stmtNo THEN n = %MF_ENABLED ELSE n = %MF_GRAYED
            MENU SET STATE hMenu, BYCMD %IDM_REC_CLOSE, n
            s = FORMAT$(reconcileDiff/100, "#0.00")
            s = "Reconcile difference = " + s
         ELSEIF archiveMode THEN
            s = "Archiving file now... please wait"
         ELSE
            s = "File> " + thisFile
         END IF 
         IF viewMoEntries AND numSelected = 0 THEN viewMoEntries = 0
         SendMessage hStatus, %SB_SETTEXT, 0, BYVAL STRPTR(s)
      CASE 2
         back = 1
         IF grpFound THEN
            s = "- Showing found entries"
         ELSEIF viewStmtMode THEN
            s = "- Viewing statement " + getDate(stmt(viewStmtMode).date)
         ELSEIF reconcileMode THEN
            s = "- Reconciling statement " + getDate(stmt(stmtNo).date)
         ELSE
            back = 0
         END IF 
         ti = "Check Book"
         IF archiveFile THEN ti = ti + " " + "Archive"
         DIALOG SET TEXT hDlg, ti + " " + s
         n = active(selector)
         IF n THEN s = "Acct> " + acctName(entry(n).acct)
         SendMessage hStatus, %SB_SETTEXT, 1, BYVAL STRPTR(s)
         IF back THEN s = "Back" ELSE s = "Quit"
         CONTROL SET TEXT hDlg, %IDC_QuitBtn, s
         MENU SET TEXT hMenu, BYCMD %IDM_VIEW_QUIT, "&" + s + $TAB + "F4"
      CASE 3
         s = STR$(selector) + " : " + TRIM$(STR$(numActive))
         SendMessage hStatus, %SB_SETTEXT, 2, BYVAL STRPTR(s)
   END SELECT
END SUB

SUB repaintScrn
   showInit = 1: updateScrn
END SUB

SUB resetCatgList(income AS LONG, dlg AS LONG, ctrl AS LONG)
   'set catgList(0,1,2,3,...) -> transfer, split, catg1, catg2,...
   LOCAL i AS LONG, j AS LONG, n AS LONG, first AS LONG, last AS LONG
   LOCAL sz AS ASCIIZ*64
   COMBOBOX RESET dlg, ctrl
   IF dlg = hDlg THEN 'add transfer and split first
      COMBOBOX ADD dlg, ctrl, "Transfer"
      COMBOBOX ADD dlg, ctrl, "Split"
   END IF
   first = 1: last = numCatgs                     
   IF income = 0 THEN last = numExpenses          'show expenses only
   IF income = 1 THEN first = numExpenses + 1     'show income only
   FOR i = first TO last
      IF catg(i).subcatg = 0 THEN
         sz = catgName(i)
         CONTROL SEND dlg, ctrl, %CB_ADDSTRING, 0, VARPTR(sz) TO j
         CONTROL SEND dlg, ctrl, %CB_SETITEMDATA, j, i
      END IF
   NEXT i
END SUB

SUB resetSubcatgList(n AS LONG, dlg AS LONG, ctrl AS LONG)
   'reset subcategories for category n
   LOCAL i AS LONG
   IF n < 0 THEN EXIT SUB
   COMBOBOX RESET dlg, ctrl
   IF dlg = hDlg AND n = 0 THEN 'transfer
      FOR i = 1 TO numAccts
         COMBOBOX ADD hDlg, %IDC_AddSubcatg, acctName(i)
      NEXT i
   ELSE
      i = 1
      WHILE i <= numCatgs AND catg(n + i).subcatg
         COMBOBOX ADD dlg, ctrl, catgName(n + i): INCR i
      WEND
   END IF
END SUB

SUB setMenuState(OPT BYVAL x AS LONG)
   'x = 1 reset menu state due only to changing entry selections
   LOCAL n AS LONG, k AS WORD, s AS STRING
   IF numActive THEN 'when selector is on a split transaction
      n = active(selector): k = entry(n).stmt
      IF BIT(entry(n).flag, 7) THEN n = %MF_ENABLED ELSE n = %MF_GRAYED
      IF windowNo AND windowNo < 10 THEN n = %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_SPLIT, n
   END IF
   IF viewMoEntries THEN 
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTONE, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTALL, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_DESELECT, %MF_ENABLED
   ELSEIF numSelected THEN 
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_ENTRY, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_DESELECT, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_EDIT_CHGGROUP, %MF_ENABLED
   ELSE
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTONE, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTALL, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_ENTRY, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_VIEW_DESELECT, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_EDIT_CHGGROUP, %MF_GRAYED
   END IF
   n = %MF_ENABLED
   IF clearedEntry OR k OR viewMoEntries THEN n = %MF_GRAYED
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_DELENTRY, n
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_VOIDENTRY, n
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_MOVENTRY, n
   IF x THEN EXIT SUB
   IF reconcileMode OR viewStmtMode THEN
      MENU SET STATE hMenu, BYCMD %IDM_REC_BEGIN, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_TASKS_ACCTS, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_TASKS_STMTS, %MF_GRAYED
   ELSE
      IF stmtNo THEN s = "&Continue" ELSE s = "&Begin"
      MENU SET TEXT hMenu, BYCMD %IDM_REC_BEGIN, s + $TAB + "F5"
      MENU SET STATE hMenu, BYCMD %IDM_REC_BEGIN, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_TASKS_ACCTS, %MF_ENABLED
      MENU SET STATE hMenu, BYCMD %IDM_TASKS_STMTS, %MF_ENABLED
   END IF 
   IF viewStmtMode OR archiveFile THEN
      MENU SET STATE hMenu, BYCMD %IDM_FILE_ARCHIVE, %MF_GRAYED
      MENU SET STATE hMenu, BYCMD %IDM_REC_BEGIN, %MF_GRAYED
      FOR k = 1 TO 13
         MENU SET STATE hEditMenu, k, %MF_GRAYED
      NEXT k
   ELSE
      MENU SET STATE hEditMenu, 4, %MF_ENABLED
      IF reconcileMode THEN n = %MF_ENABLED ELSE n = %MF_GRAYED
      FOR k = 1 TO 4
         MENU SET STATE hMenu, BYCMD %IDM_REC_BEGIN + k, n
      NEXT m
   END IF
END SUB

SUB toggleWindowState
   'toggle register and entry mode - reset labels and buttons
   LOCAL m AS LONG, n AS LONG, s AS STRING 
   IF windowNo THEN n = %WHITE ELSE n = %BLACK
   CONTROL SET COLOR hDlg, %IDC_LABEL1, n, %LTGRAY
   CONTROL SHOW STATE hDlg, %IDC_LABEL1, %SW_HIDE
   CONTROL SHOW STATE hDlg, %IDC_LABEL1, %SW_SHOW
   IF windowNo THEN n = %BLACK ELSE n = %WHITE
   CONTROL SET COLOR hDlg, %IDC_LABEL2, n, %LTGRAY
   CONTROL SHOW STATE hDlg, %IDC_LABEL2, %SW_HIDE
   CONTROL SHOW STATE hDlg, %IDC_LABEL2, %SW_SHOW
   CONTROL SET COLOR hDlg, %IDC_LABEL3, n, %LTGRAY
   CONTROL SHOW STATE hDlg, %IDC_LABEL3, %SW_HIDE
   CONTROL SHOW STATE hDlg, %IDC_LABEL3, %SW_SHOW 
   s = "Entry": n = %MF_ENABLED
   IF windowNo AND windowNo < 10 THEN s = "Register": n = %MF_GRAYED
   s = s + " Mode" + $TAB + "F2"
   MENU SET TEXT hMenu, BYCMD %IDM_VIEW_ENTRY, s
   IF windowNo THEN n = %MF_GRAYED ELSE n = %MF_ENABLED
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_ADDMOENTRY, n
   MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTONE, n
   MENU SET STATE hMenu, BYCMD %IDM_VIEW_SELECTALL, n
   MENU SET STATE hMenu, BYCMD %IDM_VIEW_DESELECT, n
END SUB

FUNCTION MakeFont(hDC AS LONG, sFont AS STRING, BYVAL ptSize AS LONG, _
                  OPT BYVAL descr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL CyPixels AS LONG, charHt AS LONG, wt AS DWORD
   LOCAL bold AS DWORD, underline AS DWORD, italic AS DWORD
   IF LEN(descr) THEN
      bold = INSTR(descr, "b") + 300
      underline = INSTR(descr,"u")
      italic = INSTR(descr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (PtSize * CyPixels) \ 72
   wt = %FW_NORMAL + bold
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION

SUB showText(hDC AS LONG, x AS LONG, y AS LONG, txt AS STRING)
   TextOut hDC, x, y, BYVAL STRPTR(txt), LEN(txt)
END SUB

SUB recalcBalances
   LOCAL i AS LONG, n AS LONG
   REDIM qbal(numActive) AS QUAD
   IF numActive < 1 THEN EXIT SUB
   qbal(numActive) = acct(acctNo).endBal
   FOR i = numActive TO 1 STEP -1
      n = active(i)
      IF BIT(entry(n).flag, 4) THEN
         qbal(i - 1) = qbal(i)
      ELSE
         qbal(i - 1) = qbal(i) + entry(n).amt
      END IF
   NEXT i
END SUB

SUB updateAcct
   'construct active() and bal() for the acnCount
   LOCAL i AS LONG, n AS LONG
   REDIM active(numEntries)
   IF acctOpt = 3 THEN  'check for open statement if acnCount has changed
      stmtNo = 0: reconcileMode = 0: acctOpt = 0  
      FOR i = 1 TO numStmts
         IF stmt(i).acct = acctNo AND stmt(i).closed <> 1 THEN
            stmtNo = i: EXIT FOR
         END IF   
      NEXT i
   END IF
   numActive = 0: selector = 0
   FOR i = 1 TO numEntries
      IF entry(i).acct = acctNo AND BIT(entry(i).flag, 5) = 0 THEN
         IF grpFound THEN 
            IF BIT(entry(i).flag, 2) = 0 THEN ITERATE 'not a found entry
         ELSEIF viewStmtMode THEN 
            IF stmt(viewStmtMode).closed = 2 THEN
               IF entry(i).stmt THEN ITERATE
            ELSE
               IF entry(i).stmt <> viewStmtMode THEN ITERATE 'not the one 
            END IF
         ELSEIF reconcileMode THEN
            IF entry(i).stmt THEN ITERATE 'already reconciled
         END IF
         INCR numActive: active(numActive) = i
         IF i = entryNo THEN selector = numActive
      END IF
   NEXT i
   updatePayees
   IF selector = 0 THEN selector = numActive
   setMenuState: reCalcBalances
   n = topEntry
   IF selector <= numDisplayed THEN
      topEntry = 1
   ELSEIF selector > numActive - numDisplayed THEN
      topEntry = numActive - numDisplayed + 1
   ELSEIF selector >= n AND selector < n + numDisplayed THEN
      topEntry = n
   ELSE
      topEntry = selector - numDisplayed / 2
   END IF: vPos = topEntry
   si.cbSize = SIZEOF(si): si.fMask = %SIF_ALL
   si.nMin = 1: si.nMax = numActive: si.nPos = vPos: si.nPage = numDisplayed
   SetScrollInfo BYVAL hScrollBar, BYVAL %SB_CTL, si, 1
   updatedAcct = 1: updateScrn: statusLine 1: statusLine 2: windowNo = 0
   IF acctOpt = 3 THEN acctOpt = 0: reconcileMode = SGN(stmtNo) 
   clearEntry: CONTROL SET FOCUS hDlg, %IDC_Kbd
END SUB

SUB updatePayees
   LOCAL i AS LONG, n AS LONG, s AS STRING
   CONTROL GET TEXT hDlg, %IDC_AddPayee TO s 'save contents
   COMBOBOX RESET hDlg, %IDC_AddPayee
   DIM xPayee(numPayees) AS BYTE
   FOR i = 1 TO numEntries
      IF entry(i).acct = acctNo THEN
         n = entry(i).payee
         IF n AND xPayee(n) = 0 THEN
            COMBOBOX ADD hDlg, %IDC_AddPayee, payee(n): xPayee(n) = 1
         END IF
      END IF
   NEXT i
   CONTROL SET TEXT hDlg, %IDC_AddPayee, s   'restore contents
END SUB

SUB truncateStr(hdc AS LONG, s AS STRING, allowExt AS LONG)
   'hdc = device context, allowExt = allowable length in pixels
   LOCAL sz AS ASCIIZ*128, n AS LONG, nFit AS LONG, cSize AS SIZEL
   sz = s: n = LEN(s)
   GetTextExtentExPoint BYVAL hdc, BYVAL VARPTR(sz), n, BYVAL allowExt,_
                        BYVAL VARPTR(nFit), BYVAL %NULL, BYVAL VARPTR(cSize)
   s = LEFT$(s, nFit)
END SUB

FUNCTION leftAdj(hdc AS LONG, s AS STRING, j AS LONG) AS LONG
   'pad s with maximum number of trailing blanks, and return length of s
   'note that j = number of logical units
   LOCAL t AS SIZEL, sz AS ASCIIZ * 128, n AS LONG
   sz = s: GetTextExtentPoint32 hdc, sz, LEN(sz), t
   n = t.cx: sz = s + SPACE$(INT((j - n)/blankLen))
   GetTextExtentPoint32 hdc, sz, LEN(sz), t
   FUNCTION = t.cx: s = sz
END FUNCTION

FUNCTION rightAdj(hdc AS LONG, s AS STRING, j AS LONG) AS LONG
   'pad s with maximum number of leading blanks, and return length of s
   'note that j = number of logical units
   LOCAL t AS SIZEL, sz AS ASCIIZ * 128, n AS LONG
   sz = s: GetTextExtentPoint32 hdc, sz, LEN(sz), t
   n = t.cx: sz = SPACE$(INT((j - n)/blankLen)) + s
   GetTextExtentPoint32 hdc, sz, LEN(sz), t
   FUNCTION = t.cx: s = sz
END FUNCTION

SUB showLine(hdc AS LONG, i AS WORD, j AS LONG)
   'show the lines in the check book register
   'hdc = applicable device context
   '  i = active entry number
   '  j = vertical position
   LOCAL k AS LONG, m AS LONG, mm AS LONG
   LOCAL n AS LONG, nn AS DWORD, s AS STRING
   n = active(i)
   nn = numVal(entry(n).date)
   k = vLine(0) + 1
   m = leftAdj(hdc, s, vLine(1)-vLine(0)-1)
   showText hdc, k, j, getDate(nn) '------------------------------- date
   nn = numVal(entry(n).ckNo)
   s = TRIM$(STR$(nn)): IF nn = 0 THEN s = ""
   k = vLine(2)- 2
   m = rightAdj(hdc, s, vLine(2)-vLine(1)-2)
   showText hdc, k - m, j, s '------------------------------------- ckNo
   s = SPACE$(2) + payee(entry(n).payee)
   k = vLine(2) + 1
   mm = vLine(3) - vLine(2) - 1
   m = leftAdj(hdc, s, mm)
   showText hdc, k, j, s '---------------------------------------- payee
   s = ""
   IF BIT(entry(n).flag, 0) THEN s = " C"
   IF entry(n).stmt THEN s = " R"
   IF LEN(s) = 0 THEN
      nn = (vLine(4)-vLine(3)-1)/blankLen
      s = SPACE$(INT(nn))
   END IF
   showText hdc, vLine(3)+1, j, s '----------------------------------- c
   nn = (vLine(5)-vLine(4)-1)/blankLen
   s = SPACE$(INT(nn))
   showText hdc, vLine(4)+1, j, s '--------------------------- clear pay
   showText hdc, vLine(5)+1, j, s '--------------------------- clear dep
   s = FORMAT$(ABS(entry(n).amt)/100, "#0.00")
   IF entry(n).amt > 0 THEN nn = 4 ELSE nn = 5
   k = vLine(nn+1) - 2
   m = rightAdj(hdc, s, vLine(nn+1)-vLine(nn)-2)
   showText hdc, k - m, j, s '------------------------------- pay or dep
   n = 1: s = ""
   IF reconcileMode OR viewStmtMode OR archiveFile THEN n = 0
   IF grpFound OR printing THEN n = 0
   IF n THEN s = FORMAT$(qbal(i)/100, "#0.00")
   k = vLine(8) - 2
   m = rightAdj(hdc, s, vLine(8)-vLine(7)-2)
   IF GetTextColor(hdc) = &H00FFFFFF THEN  'white text in selector
      IF qbal(i) < 0 THEN SetTextColor hdc, RGB(255, 255, 0) 'yellow text
   ELSE
      IF qbal(i) < 0 THEN SetTextColor hdc, RGB(255, 0, 0) 'red text
   END IF
   IF BIT(entry(active(i)).flag, 4) THEN s = "   void ************ "
   showText hdc, k - m, j, s '---------------------------------- balance
END SUB

SUB updateScrn
   LOCAL i AS WORD, j AS LONG, n AS LONG, m AS LONG
   LOCAL k AS WORD, s AS STRING, t AS SIZEL, sz AS ASCIIZ*100
   LOCAL x AS LONG, y AS LONG, r AS RECT
   REDIM vLine(9)
   DATA 12, 65, 124, 350, 364, 434, 506, 508, 592, 611
   FOR i = 0 TO 9 'read vert line positions
      vLine(i) = VAL(READ$(i + 1))
   NEXT i
   IF showInit THEN 'initialize empty checkbook register ---------------------
      hFont = makeFont(memdc, "MS Sans Serif", 12)
      hOrigFont = SelectObject(memdc, hFont)
      SetTextColor memdc,RGB(0, 0, 0)
      FOR i = 1 TO numDisplayed
         n = 255 * (i MOD 2) 'alternate background color
         SetBkColor memdc, RGB(n, 255, 255)
         showText memdc, 12, %Top + 11 + 15*i, SPACE$(145)
      NEXT i
      DeleteObject SelectObject(memdc, hOrigFont)
   END IF
   'show checkbook register lines --------------------------------------------
   hFont = makeFont(memdc, "MS sans serif", fontSize)
   hOrigFont = SelectObject(memdc, hFont)
   sz = SPACE$(100): GetTextExtentPoint32 memdc, sz, 100, t
   blankLen = t.cx/100
   IF topEntry < 1 THEN wrapUp
   'show all displayed entries -----------------------------------------------
   FOR i = topEntry TO topEntry + numDisplayed - 1
      j = i - topEntry + 1
      n = 255 * (j MOD 2) 'alternate background color
      SetTextColor memdc,RGB(0, 0, 0)
      SetBkColor memdc, RGB(n, 255, 255)
      IF i <= numActive AND BIT(entry(active(i)).flag, 2) THEN
         SetBkColor memdc, RGB(255, 255, 0) 'color selected entries
      END IF
      IF i = selector THEN
         SetTextColor memdc, RGB(255, 255, 255)
         SetBkColor memdc, RGB(255, 64, 64)
      END IF
      showText memdc, 12, %Top + 11 + 15*j, SPACE$(193)
      IF i <= numActive THEN showLine memdc, i, %Top + 11 + 15*j
      FOR m = 0 TO 9 'to steady vert lines for fast scrolling
         MoveToEx memdc, vLine(m), regTop, BYVAL %NULL
         LineTo memdc, vLine(m), regBottom
      NEXT m
   NEXT i
   'and now show the selector ------------------------------------------------
   IF prevSelector > numActive THEN prevSelector = selector
   m = selector - topEntry + 1: n = prevSelector - topEntry + 1
   k = selector - prevSelector
   IF updatedAcct THEN 'updated active() in updateAcct
      prevSelector = n + topEntry - 1
      IF prevSelector > numActive THEN n = m
   END IF
   IF n >= 1 AND n <= numDisplayed AND n <> m AND k THEN
      i = 255 * (n MOD 2) 'alternate background color
      SetTextColor memdc,RGB(0, 0, 0)
      SetBkColor memdc, RGB(i, 255, 255)
      j = n + topEntry - 1
      IF j <=numActive AND BIT(entry(active(j)).flag, 2) THEN
         SetBkColor memdc, RGB(255, 255, 0)
      END IF
      j = %Top + 11 + 15*n
      showText memdc, 12, j, SPACE$(193)
      showLine memdc, prevSelector, j  'topEntry
   END IF
   IF m >= 1 AND m <= numDisplayed AND selector THEN
      n = active(selector): x = 255: y = 64
      IF BIT(entry(n).flag, 2) THEN x = 0: y = 0
      SetTextColor memdc,RGB(255, 255, 255)
      SetBkColor memdc, RGB(x, y, y)
      j = %Top + 11 + 15*m
      showText memdc, 12, j, SPACE$(193)
      showLine memdc, selector, j
      m = entry(n).memo
      IF m AND m <= numMemos THEN s = memo(m) ELSE s = ""
      CONTROL SET TEXT hDlg, %IDC_Memo, "Memo> " + s
      IF numCatgs THEN s = getCatg(n) ELSE s = "" 
      CONTROL SET TEXT hDlg, %IDC_Catg, "Catg> " + s
   END IF
   statusLine 2: statusLine 3
   prevSelector = selector
wrapUp:
   FOR i = 0 TO 9
      MoveToEx memdc, vLine(i), regTop, BYVAL %NULL
      LineTo memdc, vLine(i), regBottom
   NEXT i
   r.nLeft = 0: r.nRight = 593
   r.nTop = regTop: r.nBottom = regBottom
   InvalidateRect hDlg, r, 0
   r.nLeft = 611: r.nRight = 615
   r.nTop = regTop: r.nBottom = regBottom
   InvalidateRect hDlg, r, 0
   IF noPaint = 0 THEN UpdateWindow hDlg
   DeleteObject SelectObject(memdc, hOrigFont)
   showInit = 0: dlgResult = 0: updatedAcct = 0: noPaint = 0
END SUB

SUB addMoEntries
   'add monthly entries
   'moEntry = 0 cancel all entries
   '        = 1 entry not finished
   '        = 2 entry finished
   LOCAL i AS LONG, j AS LONG, k AS LONG, savSelector AS LONG 
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_DELMOENTRY, %MF_ENABLED 
   savSelector = selector 
   FOR i = 1 TO 13
      IF i <> 5 THEN MENU SET STATE hEditMenu, i, %MF_GRAYED
   NEXT i  
   MENU SET TEXT hMenu, BYCMD %IDM_EDIT_MOENTRIES, "End"
   CONTROL DISABLE hDlg, %IDC_FindBtn
   FOR i = 1 TO numPayees
      IF moPayee(i) THEN k = 1 ELSE ITERATE
      j = numActive
      DO UNTIL j = 0 'scan for entry with matching monthly payee
         IF entry(active(j)).payee = i THEN EXIT DO ELSE DECR j
      LOOP
      IF j THEN
         selector = j: moEntry = 1
         DIALOG SEND hDlg, %WM_COMMAND, %IDM_EDIT_DUPENTRY, 0
         selector = savSelector
         WHILE moEntry = 1: DIALOG DOEVENTS: WEND
         IF moEntry = 0 THEN EXIT FOR
      END IF
   NEXT i
   CONTROL SET TEXT hDlg, %IDC_NewBtn, "New"
   FOR i = 1 TO 13
      MENU SET STATE hEditMenu, i, %MF_ENABLED
   NEXT i
   MENU SET TEXT hMenu, BYCMD %IDM_EDIT_MOENTRIES, "Enter now"
   MENU SET STATE hMenu, BYCMD %IDM_EDIT_DELMOENTRY, %MF_GRAYED 
   CONTROL ENABLE hDlg, %IDC_FindBtn
   moEntry = 0: clearEntry: CONTROL SET FOCUS hDlg, %IDC_Kbd
   IF k = 0 THEN MSGBOX "No monthly payees to process", , "Monthly Entries"
END SUB

FUNCTION validDate(s AS STRING) AS LONG
   'return -1 if valid date, otherwise return 0
   'return with standard form of date: s = "10/13/1934"
   LOCAL mo AS STRING, day AS STRING, yr AS STRING, yyr AS STRING
   LOCAL ss AS STRING, m AS LONG, y AS LONG, n AS LONG
   FUNCTION = -1: mo = PARSE$(s, ANY "-/", 1)
   day = PARSE$(s, ANY "-/", 2): yr = PARSE$(s, ANY "-/", 3)
   IF LEN(yr) = 0 THEN 'augment date if left off
      ss = lastDate: yyr = PARSE$(ss, ANY "-/", 3)
      IF LEN(yyr) = 0 THEN yyr = RIGHT$(PARSE$(DATE$, ANY "-/", 3), 2)
      yr = yyr
   END IF
   y = VAL(yr): IF y > 80 THEN y = 1900 + y ELSE y = 2000 + y
   m = VAL(mo): IF m < 1 OR m > 12 THEN FUNCTION = 0: EXIT FUNCTION
   n = VAL(day): IF n > daysInMonth(m, y) THEN FUNCTION = 0: EXIT FUNCTION
   s = mo + "/" + day + "/" + yr
END FUNCTION

SUB showEntry
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   LOCAL s AS STRING, sz AS ASCIIZ * 32
   FOR i = 0 TO 7
      IF i < 6 THEN
         CONTROL SET TEXT hDlg, %IDC_AddDate + i, fields(i)
         CONTROL SEND hDlg, %IDC_AddDate + i, %EM_SETSEL, 0, -1
      ELSEIF i = 6 THEN
         sz = fields(6): IF LEN(fields(4)) THEN j = 1 
         resetCatgList j, hDlg, %IDC_AddDate + i
         CONTROL SEND hDlg, %IDC_AddCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m
         CONTROL SEND hDlg, %IDC_AddCatg, %CB_GETITEMDATA, m, 0 TO n
         COMBOBOX SELECT hDlg, %IDC_AddCatg, m + 1
      ELSEIF m >= 0 THEN
         sz = fields(7)
         resetSubcatgList n, hDlg, %IDC_AddSubcatg
         CONTROL SEND hDlg, %IDC_AddSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m
         COMBOBOX SELECT hDlg, %IDC_AddSubcatg, m + 1
      END IF   
   NEXT i
END SUB

SUB addEntry
   LOCAL m AS LONG, n AS LONG, i AS LONG, k AS LONG
   LOCAL sz AS ASCIIZ * 64, s AS STRING, sCatg AS STRING
   LOCAL q AS QUAD, qq AS QUAD, temp AS entryData, title AS STRING
   LOCAL nDate AS LONG, catgType AS LONG, cleared AS BYTE
   CONTROL GET TEXT hDlg, %IDC_AddDate TO s
   windowNo = 0: title = "Cannot enter data"
   IF NOT validDate(s) THEN
      MSGBOX "Must specify a valid date", , title
      nextField = %IDC_addDate: EXIT SUB
   END IF
   nDate = storDate(s)
   temp.date = NumStr(nDate)
   CONTROL GET TEXT hDlg, %IDC_AddPayee TO s
   s = TRIM$(s)
   IF LEN(s) = 0 THEN
      MSGBOX "Must specify a name", 1, title
      nextField = %IDC_addPayee: EXIT SUB
   END IF
   IF numPayees THEN
      DIM xpayee(1:numPayees) AS STRING AT VARPTR(payee(1))
      ARRAY SCAN xpayee(), COLLATE UCASE, = UCASE$(s), TO k
   END IF
   IF k THEN
      temp.payee = k
   ELSE
      INCR numPayees: temp.payee = numPayees
      REDIM PRESERVE payee(numPayees)
      payee(numPayees) = s
      COMBOBOX ADD hDlg, %IDC_AddPayee, s
   END IF
   CONTROL GET TEXT hDlg, %IDC_AddPay TO s: q = 100 * VAL(s)
   IF q = 0 THEN
      CONTROL GET TEXT hDlg, %IDC_AddDep TO s: q = -100 * VAL(s)
   END IF
   IF q = 0 THEN
      MSGBOX "Must specify an amount... pay or dep", , title
      nextField = %IDC_AddPay: EXIT SUB
   ELSE
      'IF editMode AND entry(editMode).stmt AND q <> entry(editMode).amt THEN
      cleared = BIT(entry(editMode).flag, 0)  
      IF editMode AND cleared AND q <> entry(editMode).amt THEN 
         MSGBOX "Cannot change amount for cleared entry", , title
         qq = entry(editMode).amt
         IF qq > 0 THEN m = %IDC_AddPay: n = %IDC_AddDep _
                   ELSE m = %IDC_AddDep: n = %IDC_AddPay
         CONTROL SET TEXT hDlg, m, FORMAT$(ABS(qq)/100, "#0.00")
         CONTROL SET TEXT hDlg, n, "": nextField = m: EXIT SUB
      END IF
      IF ABS(q) > 2147483647 THEN
         IF q > 0 THEN nextField = %IDC_AddPay ELSE nextField = %IDC_AddDep
         MSGBOX "Amount exceeds program limits", , title: EXIT SUB
      END IF
   END IF
   CONTROL GET TEXT hDlg, %IDC_AddCatg TO sz
   CONTROL SEND hDlg, %IDC_AddCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m 
   catgType = m + 1
   IF m = 0 THEN 'transfer
      CONTROL GET TEXT hDlg, %IDC_AddSubcatg TO s
      ARRAY SCAN acctName(), COLLATE UCASE, = s, TO m
      IF m = 0 THEN
         MSGBOX "Transfer category - improper acnCount selected" + $CRLF _
                + "... select acnCount from sub category list", , title
         nextField = %IDC_addSubcatg: EXIT SUB
      END IF
      temp.catg = m - 1
'   ELSEIF m = 1 THEN 'split 
'      IF editMode THEN splitStr = split(entry(editMode).catg)
'      IF LEN(splitStr) = 0 THEN splitOpt = 1: processSplit
   END IF
   'ok to add entry --------------------------------------------------
   IF userPrompt THEN
      userPrompt = 0: s = "Enter data into register now?" 
      k = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Register Data")
      IF k = %IDNO THEN nextField = %IDC_addDate: EXIT SUB
   END IF
   nextField = 0
   lastDate = getDate(nDate)
   CONTROL GET TEXT hDlg, %IDC_AddCkNo TO s: s = TRIM$(s)
   temp.ckNo = NumStr(VAL(s))
   IF LEN(s) THEN acct(acctNo).lastCkNo = VAL(s)
   temp.amt = q
   temp.acct = acctNo
   temp.stmt = 0
   IF editMode THEN
      temp.flag = entry(editMode).flag
      temp.stmt = entry(editMode).stmt
      BIT SET entry(editMode).flag , 5 'deleted
      IF BIT(entry(editMode).flag, 4) = 0 THEN 'not void
         acct(acctNo).endBal = acct(acctNo).endBal + entry(editMode).amt
      END IF
      IF BIT(entry(editMode).flag, 0) THEN
         reconcileDiff = reconcileDiff - entry(editMode).amt
      END IF
      IF BIT(entry(editMode).flag, 6) THEN 'must find and delete transferred entry
         n = entry(editMode).catg            'acct of transferred entry
         m = numVal(entry(editMode).date)    'date of transferred entry
         k = entry(editMode).amt             'amount of transferred entry
         FOR i = 1 TO numEntries
            IF entry(i).acct = n AND BIT(entry(i).flag, 5) = 0 AND BIT(entry(i).flag, 6) AND _
               entry(i).catg = acctNo AND numVal(entry(i).date) = m AND entry(i).amt = -k THEN 'found 
               BIT SET entry(i).flag, 5
               acct(n).endBal = acct(n).endBal - k
               EXIT FOR
            END IF 
         NEXT i
      END IF
      someDeleted = 1
   END IF
   IF reconcileMode THEN 
      BIT SET temp.flag, 0 'set as cleared
      reconcileDiff = reconcileDiff + temp.amt
      'IF editMode THEN reconcileDiff = reconcileDiff - entry(editMode).amt 
   END IF   
   IF moEntry THEN BIT SET temp.flag, 1 'set as monthly entry
   CONTROL GET TEXT hDlg, %IDC_AddCatg TO s: sz = TRIM$(s): sCatg = sz 
   IF LEN(sCatg) AND BIT(grpChange, 2) = 0 THEN
      CONTROL SEND hDlg, %IDC_AddCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m
      CONTROL SEND hDlg, %IDC_AddCatg, %CB_GETITEMDATA, m, 0 TO k
      CONTROL GET TEXT hDlg, %IDC_AddSubcatg TO s: sz = TRIM$(s)
      CONTROL SEND hDlg, %IDC_AddSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO n
      IF m = 0 THEN 'transfer 
         BIT SET temp.flag, 6
      ELSEIF m = 1 THEN 'split
         BIT SET temp.flag, 7 
         INCR numSplits: REDIM PRESERVE split(numSplits)
         temp.catg = numSplits: split(numSplits) = splitStr
         splitStr = "": numSplitItems = 0
      ELSE 'defined catg/subcatg
         temp.catg = k + n + 1
      END IF
   ELSE
      temp.catg = 0
   END IF
   CONTROL GET TEXT hDlg, %IDC_AddMemo TO s
   IF LEN(s) AND BIT(grpChange, 1) = 0 THEN 'entry has a memo
      INCR numMemos: REDIM PRESERVE memo(numMemos)
      temp.memo = numMemos: memo(numMemos) = s
   END IF
   ARRAY SCAN entry(), FROM 1 TO 8, > temp.date + temp.ckNo, TO k
   INCR numEntries
   IF k = 0 THEN k = numEntries
   REDIM PRESERVE entry(1:numEntries)
   ARRAY INSERT entry(k), temp
   acct(acctNo).endBal = acct(acctNo).endBal - temp.amt 'update end balance
   IF BIT(temp.flag, 6) THEN 'add transferred amt to other acct
      temp.flag = 64: temp.amt = -temp.amt
      n = temp.catg: temp.acct = n: temp.catg = acctNo
      ARRAY SCAN entry(), FROM 1 TO 8, > temp.date + temp.ckNo, TO k
      INCR numEntries
      IF k = 0 THEN k = numEntries
      REDIM PRESERVE entry(1:numEntries)
      ARRAY INSERT entry(k), temp
      acct(n).endBal = acct(n).endBal - temp.amt 'update end balance
   END IF
   fileChanged = 1: splitOpt = 0: entryNo = k
   IF grpChange = 0 THEN updateAcct
   IF reconcileMode THEN
      statusLine 1
      IF cleared = 0 AND stmt(stmtNo).date < acct(acctNo).beginDate THEN
         acct(acctNo).endbal = acct(acctNo).endbal + temp.amt
      END IF
      IF reconcileDiff = 0 THEN  'ok to close statement
         DIALOG SEND hDlg, %WM_COMMAND, %IDM_REC_CLOSE, 0
      END IF
   END IF
END SUB

FUNCTION storDate(s AS STRING) AS LONG
   LOCAL n AS LONG
   DIM sParse(1:3) AS STRING
   IF LEN(s) = 0 THEN EXIT FUNCTION
   PARSE s, sParse(), ANY "/-"
   sParse(1) = RIGHT$("0" + sParse(1), 2)
   sParse(2) = RIGHT$("0" + sParse(2), 2)
   n = VAL(sParse(3))
   IF  n < 80 THEN
      n = 2000 + n
   ELSEIF n < 100 THEN
      n = 1900 + n
   END IF
   FUNCTION = 10000 * n + VAL(sParse(1) + sParse(2))
END FUNCTION

FUNCTION getDate(n AS LONG) AS STRING
   LOCAL s AS STRING
   s = TRIM$(STR$(n))
   FUNCTION = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + MID$(s, 3, 2)
END FUNCTION

SUB getFields(n AS LONG)
   'get the 8 fields for entry(n)... fields(0) to fields(7)
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG
   LOCAL s AS STRING, s1 AS STRING
   REDIM fields(7)
   j = numVal(entry(n).date)
   fields(0) = getDate(j)
   j = numVal(entry(n).ckNo)
   IF j THEN fields(1) = TRIM$(STR$(j))
   fields(2) = payee(entry(n).payee)
   s = FORMAT$(ABS(entry(n).amt)/100, "#0.00")
   IF entry(n).amt > 0 THEN j = 3 ELSE j = 4
   fields(j) = s
   m = entry(n).memo
   IF m AND m <= numMemos THEN fields(5) = memo(m)
   i = entry(n).catg
   IF i THEN
      IF BIT(entry(n).flag, 6) THEN 'transfer
         s = "Transfer": s1 = acctName(i)
      ELSEIF BIT(entry(n).flag, 7) THEN 'split
         s = "Split": s1 = ""
      ELSEIF i THEN
         s = catgName(i): m = catg(i).Subcatg
         IF m THEN s1 = s: k = i - m: s = catgName(k)
      END IF
      fields(6) = s
      fields(7) = s1
   END IF
END SUB

FUNCTION getCatg(n AS LONG) AS STRING
   'returns catg - subCatg string for entry n
   LOCAL i AS LONG, j AS LONG, m AS WORD, s AS STRING
   m = entry(n).catg
   IF BIT(entry(n).flag, 6) THEN 'transfer
      i = entry(n).catg
      IF i AND i <= numAccts THEN
         IF entry(n).amt > 0 THEN s = "to " ELSE s = "from "
         FUNCTION = "Transfer " + s + acctName(i)
      END IF
   ELSEIF BIT(entry(n).flag, 7) THEN 'split
      FUNCTION = "Split transaction"
   ELSEIF m THEN 'defined catg/subcatg
      s = catgName(m): j = catg(m).Subcatg
      IF j THEN s = catgName(m - j) + " - " + s
      FUNCTION = s
   END IF
END FUNCTION

FUNCTION NumStr(n AS DWORD) AS STRING
   FUNCTION = STRREVERSE$(MKDWD$(n))
END FUNCTION

FUNCTION NumVal(x AS STRING*4) AS DWORD
   FUNCTION = CVDWD(STRREVERSE$(x))
END FUNCTION

SUB openIniFile()
   LOCAL fileNum AS LONG, version AS STRING
   IF LEN(DIR$("checkBook.ini")) THEN
      fileNum = FREEFILE
      OPEN "checkBook.ini" FOR INPUT AS fileNum
      INPUT #fileNum, version
      INPUT #fileNum, thisFile
      CLOSE #fileNum
   ELSE
      numAccts = 0
   END IF
END SUB

SUB saveIniFile()
   LOCAL fileNum AS INTEGER
   fileNum = FREEFILE
   OPEN origDir + "\checkBook.ini" FOR OUTPUT AS fileNum
   WRITE #fileNum, "checkBook " + $verNo
   WRITE #fileNum, thisFile
   CLOSE #fileNum
END SUB

SUB openCatgFile()                   
   LOCAL fileNum AS LONG, budget AS INTEGER, tax AS STRING, s AS STRING, sCatg AS STRING
   LOCAL i AS BYTE, j AS BYTE, k AS BYTE, m AS LONG, n AS LONG, income AS BYTE, acct AS BYTE
   REDIM catg(1:255) AS catgData, catgName(255) AS STRING, tax(255) AS STRING
   IF DIR$($catgFile) = "" THEN
      s = "Category file, " + "'" + $catgFile + "'," + " not found" + $CRLF _
        + "   ... Categories will be unavailable"
      MSGBOX s, %MB_ICONWARNING, "Open Category File": EXIT SUB
   END IF
   OPEN $catgFile FOR INPUT AS fileNum
   DO UNTIL EOF(fileNum)
      LINE INPUT #fileNum, s: s = TRIM$(s): sCatg = s
      IF LEN(sCatg) THEN
         m = INSTR(s, "["): IF m THEN sCatg = LEFT$(s, m - 1)
         m = INSTR(s, "[Budget")
         IF m THEN 'budget specified
            n = INSTR(m, s, "]"):  m = m + 7: budget = VAL(MID$(s, m, n - m))
         END IF
         m = INSTR(s, "[Tax")
         IF m THEN 'tax specified
            n = INSTR(m, s, "]"):  m = m + 4: INCR k: tax(k) = MID$(s, m, n - m)
         END IF 
         IF LEFT$(s, 3) = "***" THEN
            income = 0: IF INSTR(s, "Income") THEN income = 1: numExpenses = i
            ITERATE 
         ELSEIF LEFT$(s, 1) = "-" THEN 'subCategory
            INCR i: INCR j: sCatg = MID$(sCatg, 2)
         ELSE 'category
            INCR i: j = 0
         END IF
         IF i <= 255 THEN
            catg(i).subCatg = j
            catg(i).income = income
            catg(i).taxRef = k
            catg(i).budget = budget
            catgName(i) = TRIM$(sCatg)
         END IF
      END IF 
   LOOP 
   numCatgs = i: numTaxes = k
END SUB

SUB openDialog()
   LOCAL path AS STRING, f AS STRING, s AS STRING, flags AS LONG, n AS LONG
   Path = CURDIR$: f = ""
   's = "CkBook Files (*.ckb, *.cka)|*.ckb;*.cka|All Files (*.*)|*.*"
   s = "CkBook Files (*.ckb)|*.ckb|Archive Files (*.cka)|*.cka|All Files (*.*)|*.*"
   flags = %OFN_HIDEREADONLY + %OFN_LONGNAMES + %OFN_CREATEPROMPT + %OFN_EXTENSIONDIFFERENT '+ %OFN_ENABLEHOOK
   IF ISTRUE (OpenFileDialog(BYVAL hDlg, BYVAL "Open File", _
          f, BYVAL Path, BYVAL s, BYVAL "ckb", flags)) THEN
      n = FREEFILE: s = LCASE$(f): thisFile = s
      OPEN thisFile FOR BINARY AS n
      IF LOF(n) = 0 THEN PUT n,, ckBookID
      CLOSE 
      IF INSTR(s, origDir + "\" + DIR$(s)) THEN thisFile = DIR$(s)
      IF openTheFile THEN
         saveIniFile: acctOpt = 0: dlgResult = 0
      ELSE
         dlgResult = 1
      END IF
   ELSE
      dlgResult = 2
   END IF
END SUB

FUNCTION openTheFile AS LONG
   LOCAL i AS LONG, n AS BYTE, fileNum AS LONG
   LOCAL s AS STRING, ss AS STRING, ckBkID AS STRING, sErr AS STRING
   fileNum = FREEFILE: ckBkID = ckBookID 
   OPEN thisFile FOR BINARY AS fileNum 
   GET fileNum, , ckBkID
   s = LEFT$(ckBkID, 9): ss = RIGHT$(ckBkID, 4)
   IF s <> "checkBook" AND s <> "archiveCB" THEN
      sErr = "Wrong file type"
   ELSEIF ss > RIGHT$(ckBookID, 4) THEN
      sErr = "Wrong program version for this data file - must use version " + ss
   END IF
   IF LEN(sErr) THEN
      MSGBOX sErr, , "File Open Error"
      FUNCTION = 0: CLOSE fileNum: EXIT FUNCTION
   END IF
   archiveFile = 0: fileChanged = 0
   IF s = "archiveCB" THEN archiveFile = 1 
   GET fileNum, , numEntries
   GET fileNum, , numPayees
   GET fileNum, , numAccts
   GET fileNum, , numStmts
   GET fileNum, , numCatgs 
   GET fileNum, , numMemos
   GET fileNum, , numSplits
   GET fileNum, , numTaxes
   i = MAX(numEntries, 1): REDIM entry(1:i)
   i = MAX(numStmts, 1): REDIM stmt(1:i)
   i = MAX(numAccts, 1): REDIM acct(1:i)
   i = MAX(numCatgs, 1): REDIM catg(1:i)
   REDIM payee(numPayees), acctName(numAccts), catgName(numCatgs)
   REDIM memo(numMemos), split(numSplits), tax(numTaxes), moPayee(numPayees)
   FOR i = 1 TO numEntries
      GET fileNum, , entry(i)
   NEXT i
   FOR i = 1 TO numPayees
      GET fileNum, , n
      IF n > 128 THEN n = n - 128: moPayee(i) = 1
      s = SPACE$(n): GET fileNum, , s: payee(i) = s
   NEXT i
   FOR i = 1 TO numAccts
      GET fileNum, , acct(i)
      GET fileNum, , n: s = SPACE$(n)
      GET fileNum, , s: acctName(i) = s
   NEXT i
   FOR i = 1 TO numStmts
      GET fileNum, , stmt(i)
   NEXT i
   numExpenses = 0
   FOR i = 1 TO numCatgs
      GET fileNum, , catg(i)
      IF catg(i).income = 0 THEN INCR numExpenses
      GET fileNum, , n: s = SPACE$(n)
      GET fileNum, , s: catgName(i) = s
   NEXT i
   FOR i = 1 TO numMemos
      GET fileNum, , n: s = SPACE$(n)
      GET fileNum, , s: memo(i) = s
   NEXT i
   FOR i = 1 TO numSplits
      GET fileNum, , n: s = SPACE$(n)
      GET fileNum, , s: split(i) = s
   NEXT i
   FOR i = 1 TO numTaxes
      GET fileNum, , n: s = SPACE$(n)
      GET fileNum, , s: tax(i) = s
   NEXT i
   CLOSE fileNum: FUNCTION = 1
   CONTROL SET TEXT hDlg, %IDC_Status1, "File> " + thisFile
   disableEntryMode CLNG(archiveFile)
END FUNCTION

SUB saveTheFile
   LOCAL i, m, n, savEntries, savPayees, savStmts AS WORD
   LOCAL k AS BYTE, fileNum AS LONG, s, bakName AS STRING
   IF fileChanged = 0 THEN EXIT SUB
   IF archiveFile THEN
      s = "Changes to archive files cannot be saved"
      MSGBOX s, %MB_ICONWARNING, "Save File": EXIT SUB
   END IF
   REDIM payeeUsed(numPayees) AS LONG, stmtUsed(numStmts) AS WORD
   savEntries = numEntries: savPayees = numPayees: savStmts = numStmts
   IF someDeleted OR archiveMode THEN 'determine needed payees & stmts
      numEntries = 0: numPayees = 0: numStmts = 0
      FOR i = 1 TO savEntries
         'identify used payees
         IF BIT(entry(i).flag, 5) = 0 OR archiveMode = 2 THEN
            m = entry(i).payee
            IF BIT(entry(i).flag, 5) = 0 THEN INCR numEntries
            IF payeeUsed(m) = 0 THEN INCR numPayees: payeeUsed(m) = 1
         END IF
         'identify used statements
         IF BIT(entry(i).flag, 5) = 0 THEN 'retained entry
            m = entry(i).stmt 
            IF m AND stmtUsed(m) = 0 THEN INCR numStmts: stmtUsed(m) = 1
         ELSE 'deleted entry - delete split data
            m = entry(i).catg
            IF BIT(entry(i).flag, 7) AND m THEN deleteSplit(m)
         END IF
      NEXT i
      m = 0
      FOR i = 1 TO savPayees 'define new payee indicies
         IF payeeUsed(i) THEN INCR m: payeeUsed(i) = m: payee(m) = payee(i)
      NEXT i
      n = 0
      FOR i = 1 TO savStmts 'define new statement indicies
         IF stmtUsed(i) THEN INCR n: stmtUsed(i) = n: stmt(n) = stmt(i)
      NEXT i
      FOR i = 1 TO savEntries 'apply new payee & statement indicies
         m = entry(i).payee: entry(i).payee = payeeUsed(m)
         n = entry(i).stmt: entry(i).stmt = stmtUsed(n)
      NEXT i
   END IF
   'first, create a backup file just in case
   bakName = thisFile: REPLACE ".ckb" WITH ".bak" IN bakName
   KILL bakName: NAME thisFile AS bakName
   fileNum = FREEFILE
   OPEN thisFile FOR BINARY AS fileNum
   s = ckBookID
   IF archiveMode = 1 THEN REPLACE "checkBook" WITH "archiveCB" IN s
   PUT fileNum, , s
   PUT fileNum, , numEntries
   PUT fileNum, , numPayees
   PUT fileNum, , numAccts
   PUT fileNum, , numStmts
   PUT fileNum, , numCatgs
   PUT fileNum, , numMemos
   PUT fileNum, , numSplits
   PUT fileNum, , numtaxes
   FOR i = 1 TO savEntries
      IF BIT(entry(i).flag, 5) = 0 THEN 'not deleted entry
         BIT RESET entry(i).flag, 2 'don't save selections
         PUT fileNum, , entry(i)
      END IF
   NEXT i
   FOR i = 1 TO numPayees 
         k = LEN(payee(i)): IF moPayee(i) THEN k = k + 128
         PUT fileNum, , k: PUT fileNum, , payee(i)
   NEXT i
   FOR i = 1 TO numAccts
      PUT fileNum, , acct(i): k = LEN(acctName(i))
      PUT fileNum, , k: PUT fileNum, , acctName(i)
   NEXT i
   FOR i = 1 TO numStmts
      PUT fileNum, , stmt(i)
   NEXT i
   FOR i = 1 TO numCatgs
      PUT fileNum, , catg(i): k = LEN(catgName(i))
      PUT fileNum, , k: PUT fileNum, , catgName(i)
   NEXT i
   FOR i = 1 TO numMemos
      k = LEN(memo(i))
      IF k THEN PUT fileNum, , k: PUT fileNum, , memo(i)
   NEXT i
   FOR i = 1 TO numSplits
      k = LEN(split(i))
      PUT fileNum, , k: PUT fileNum, , split(i)
   NEXT i
   FOR i = 1 TO numTaxes
      k = LEN(tax(i))
      PUT fileNum, , k: PUT fileNum, , tax(i)
   NEXT i
   CLOSE fileNum: fileChanged = 0
END SUB

FUNCTION quitProgram() AS LONG
   LOCAL n AS INTEGER, s AS STRING
   IF fileChanged THEN
      s = "File records have changed..." & $CRLF & "do you want to save them?"
      n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONWARNING, "Quit Program")
      IF n = %IDCANCEL THEN
         FUNCTION = 1: EXIT FUNCTION
      ELSEIF n = %IDYES THEN
         IF LEN(thisFile) THEN
            saveTheFile
         ELSE
            DIALOG SEND hDlg, %WM_COMMAND, %IDM_FILE_SaveAs, 0
         END IF
      END IF
   END IF
   FUNCTION = 0
END FUNCTION

SUB archiveStmts()
   LOCAL hArch AS LONG
   DIALOG NEW hDlg, "Archive Statements", , , 160, 90, %WS_SYSMENU TO hArch
   CONTROL ADD LABEL, hArch, -1, "Archive statements thru year:", 10, 10, 100, 10
   CONTROL ADD COMBOBOX, hArch, %IDC_ArchStmts, , 105, 10, 40, 100, %CBS_DROPDOWNLIST
   CONTROL ADD BUTTON, hArch, %IDOK, "Ok", 30, 40, 40, 25, %BS_DEFAULT
   CONTROL ADD BUTTON, hArch, %IDCANCEL, "Cancel", 80, 40, 40, 25
   DIALOG SHOW MODAL hArch, CALL archiveStmtsProc
END SUB

CALLBACK FUNCTION archiveStmtsProc()
   LOCAL i AS LONG, n AS LONG, s AS STRING, yr AS STRING
   LOCAL fln AS STRING, archFile AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         COMBOBOX RESET CBHNDL, %IDC_ArchStmts
         yr = "0000"
         FOR i = 1 TO numStmts
            s = LEFT$(TRIM$(STR$(stmt(i).date)), 4)
            IF s <> yr THEN yr = s: COMBOBOX ADD CBHNDL, %IDC_ArchStmts, s
         NEXT i
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            IF NOT archiveFile AND fileChanged THEN
               s = "File has changed and must be saved first" + $CRLF _
                 + "... Save file now?"
               i = MSGBOX(s, %MB_YESNO + %MB_ICONWARNING, "Archive File")
               IF i = %IDNO THEN DIALOG END CBHNDL: EXIT FUNCTION
               saveTheFile    
            END IF
            COMBOBOX GET TEXT CBHNDL, %IDC_ArchStmts TO yr 'inclusive year
            archiveMode = 1: statusLine 1
            FOR i = 1 TO numEntries 'delete non-archived entries
               n = entry(i).stmt: s = "9999": BIT RESET entry(i).flag, 5
               IF n THEN s = LEFT$(TRIM$(STR$(stmt(n).date)), 4)
               IF s > yr THEN BIT SET entry(i).flag, 5
            NEXT i
            fileChanged = 1: saveTheFile
            fln = LEFT$(thisFile, LEN(thisFile) - 4)
            archFile = fln + " " + yr + ".cka"
            KILL archFile: NAME thisFile AS archFile      'rename as archived file    
            KILL thisFile: NAME fln + ".bak" AS thisFile  'rename backup to thisFile
            openTheFile                                   'restore backup 
            FOR i = 1 TO numEntries  'delete archived entries
               n = entry(i).stmt: s = "9999": BIT RESET entry(i).flag, 5
               IF n THEN s = LEFT$(TRIM$(STR$(stmt(n).date)), 4)
               IF s <= yr THEN BIT SET entry(i).flag, 5
            NEXT i
            fileChanged = 1 
            archiveMode = 2: saveTheFile: openTheFile
            updateAcct: archiveMode = 0: statusLine 1
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN 
            DIALOG END CBHNDL
         END IF
   END SELECT
END FUNCTION

SUB selectAcct(n AS BYTE)
   'showing acnCount n as default (1st one if n = 0)
   LOCAL STYLE AS LONG
   selectAcctFcn = n: STYLE = %WS_SYSMENU
   DIALOG NEW hDlg, "Select AcnCount", , , 325, 180, STYLE TO hAcct
   hWindow = hAcct
   DIALOG SET COLOR hAcct, -1, %LTGRAY
   STYLE = %WS_VSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS OR %WS_TABSTOP
   CONTROL ADD LISTBOX, hAcct, %IDC_Accts, , 5, 15, 310, 100, STYLE
   CONTROL ADD LABEL, hAcct, -1, "   Acct Name", 5, 5, 150, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hAcct, -1, "   Acct ID", 155, 5, 90, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hAcct, -1, "        Balance", 245, 5, 60, 10, %SS_LEFT, %WS_EX_STATICEDGE
   DIALOG SHOW MODAL hAcct, CALL selectAcctProc
   reconcileMode = 0
END SUB

CALLBACK FUNCTION selectAcctProc()
   LOCAL i AS LONG, m AS LONG, n AS LONG, STYLE AS LONG
   LOCAL b AS BYTE, s AS STRING, hFile AS LONG
   'STATIC createAcct AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         n = %WS_TABSTOP
         STYLE = %BS_DEFAULT OR %WS_TABSTOP
         IF numAccts = 0 THEN n = %WS_DISABLED OR %WS_TABSTOP 
         IF acctOpt THEN 'create or edit acnCount
            DIALOG SET TEXT hAcct, "List of AcnCounts"
            IF acctOpt = 2 THEN
               s = "File> " + thisFile
               CONTROL ADD BUTTON, hAcct, %IDC_NewAcct, "Create", 30, 120, 60, 20
               hFile = CreateStatusWindow(%WS_CHILD OR %WS_VISIBLE, BYVAL(%NULL), hAcct, 700)
               DIM sbParts(0) AS LONG: sbParts(0) = -1
               SendMessage hFile, %SB_SETPARTS,1,BYVAL VARPTR(sbParts(0))
               SendMessage hFile, %SB_SETTEXT, 0, BYVAL STRPTR(s)
            ELSE
               CONTROL ADD BUTTON, hAcct, %IDC_NewAcct, "Create", 30, 120, 40, 20
               CONTROL ADD BUTTON, hAcct, %IDC_EditAcct, "Edit", 70, 120, 40, 20, n
               CONTROL ADD BUTTON, hAcct, %IDC_DelAcct, "Del", 110, 120, 40, 20, n
            END IF
            CONTROL ADD BUTTON, hAcct, %IDOK, "Open", 190, 120, 60, 20, STYLE
         ELSE
            CONTROL ADD BUTTON, hAcct, %IDOK, "Open", 160, 120, 90, 25, STYLE
         END IF
         acctOpt = 0: listAccts: hWindow = CBHNDL
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Accts
               IF CBCTLMSG = %LBN_DBLCLK THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDOK, 0
               END IF
            CASE %IDC_NewAcct
               editAcct = 0: createAcct: listAccts
            CASE %IDC_EditAcct
               CONTROL SEND CBHNDL, %IDC_Accts, %LB_GETCURSEL, 0, 0 TO i
               editAcct = i + 1: createAcct: listAccts
            CASE %IDC_DelAcct
               CONTROL SEND CBHNDL, %IDC_Accts, %LB_GETCURSEL, 0, 0 TO m
               b = m + 1: n = 0
               FOR i = 1 TO numEntries
                  IF entry(i).acct = b THEN n = 1: EXIT FOR
               NEXT i
               IF n THEN
                  s = "Must first remove all entries from acnCount" + $CRLF + _
                      "... either delete them, archive them, or move them."
                  m = %MB_OK + %MB_ICONWARNING
               ELSE
                  s = "Delete this acnCount now?"
                  m = %MB_YESNO + %MB_ICONWARNING
               END IF
               n = MSGBOX(s, m, "Delete AcnCount")
               IF n = %IDYES THEN
                  n = acctNo      
                  ARRAY DELETE acct(b)
                  ARRAY DELETE acctName(b)
                  DECR numAccts
                  IF b < acctNo THEN DECR acctNo
                  IF b < lastAcct THEN DECR lastAcct 
                  FOR i = 1 TO numEntries
                     IF entry(i).acct > b THEN DECR entry(i).acct
                  NEXT i  
                  IF b = n THEN listAccts ELSE DIALOG END CBHNDL
                  fileChanged = 1: selectAcctFcn = 0: EXIT FUNCTION
               END IF
            CASE %IDCANCEL
               DIALOG END CBHNDL
            CASE %IDOK
               IF numAccts = 0 THEN
                  openDialog: listAccts
               ELSE
                  CONTROL SEND CBHNDL, %IDC_Accts, %LB_GETCURSEL, 0, 0 TO i
                  selectAcctFcn = i + 1: DIALOG END CBHNDL
                  showInit = 1: updateScrn
               END IF
               IF reconcileMode THEN
                  DIALOG SEND hDlg, %WM_COMMAND, %IDC_QuitBtn, 0
               END IF
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         ELSEIF CBCTL = %SC_CLOSE THEN
            selectAcctFcn = 0
            IF  numAccts = 0 THEN
               s = "Must create an acnCount" + $CRLF _
                 + "or open a file with an acnCount" + $CRLF _
                 + $CRLF + "... Exit program now?"
            ELSEIF acctNo = 0 THEN
               s = "Must select an acnCount to open" + $CRLF _
                 + $CRLF + "... Exit program now?"
            END IF
            IF LEN(s) THEN
               n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Quit Program")
               IF n = %IDNO THEN FUNCTION = 1: EXIT FUNCTION
            END IF
         END IF
   END SELECT
END FUNCTION

SUB listAccts
   LOCAL i AS LONG, n AS LONG, lptr AS LONG, s AS STRING
   DIM tabstops(2) AS LONG
   tabstops(1) =  155
   tabstops(2) = -295
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hAcct, %IDC_Accts, %LB_SETTABSTOPS, 3, lptr
   LISTBOX RESET hAcct, %IDC_Accts
   FOR i = 1 TO numAccts
      s = FORMAT$(acct(i).endBal/100, "#0.00")
      s = acctName(i) + CHR$(9) + acct(i).acctID + CHR$(9) + s
      LISTBOX ADD hAcct,%IDC_Accts, s
   NEXT i
   n = selectAcctFcn: IF n = 0 THEN n = 1
   CONTROL SEND hAcct, %IDC_Accts, %LB_SETCURSEL, n - 1, 0
   CONTROL SET FOCUS hAcct, %IDC_Accts
END SUB

SUB createAcct
   LOCAL hdefAcct AS LONG, s AS STRING
   IF editAcct THEN s = "Edit" ELSE s = "Create"
   DIALOG NEW hDlg, s + " AcnCount", 20, 60, 260, 120, %WS_SYSMENU TO hdefAcct
   DIALOG SET COLOR hdefAcct, -1, %LTGRAY
   CONTROL ADD LABEL, hdefAcct, -1, "Name of acnCount:", 5, 5, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefAcct, -1, -1, %LTGRAY
   IF editAcct THEN s = "Ending" ELSE s = "Beginning"
   CONTROL ADD LABEL, hdefAcct, -2, s + " balance:", 5, 20, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefAcct, -2, -1, %LTGRAY
   CONTROL ADD LABEL, hdefAcct, -3, "Beginning date:", 5, 35, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefAcct, -3, -1, %LTGRAY
   CONTROL ADD LABEL, hdefAcct, -4, "AcnCount ID:", 5, 50, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefAcct, -4, -1, %LTGRAY
   CONTROL ADD TEXTBOX, hdefAcct, %IDC_AcctName, "", 80, 5, 160, 12
   CONTROL ADD TEXTBOX, hdefAcct, %IDC_AcctBal, "", 80, 20, 60, 12
   CONTROL ADD TEXTBOX, hdefAcct, %IDC_AcctDate, "", 80, 35, 60, 12
   CONTROL ADD TEXTBOX, hdefAcct, %IDC_AcctID, "", 80, 50, 90, 12
   CONTROL ADD FRAME, hdefAcct, -5, "", 10, 65, 120, 32
   CONTROL ADD LABEL, hdefAcct, -6, "Identifying name for the acnCount", 15, 72, 105, 10
   CONTROL SET COLOR hdefAcct, -6, -1, %LTGRAY
   CONTROL ADD LABEL, hdefAcct, -7, "", 15, 82, 100, 10
   CONTROL SET COLOR hdefAcct, -7, -1, %LTGRAY
   CONTROL ADD BUTTON, hdefAcct, %IDC_AcctOk, "&Ok", 155, 70, 40, 20
   CONTROL ADD BUTTON, hdefAcct, %IDCANCEL, "&Cancel", 200, 70, 40, 20
   PostMessage hDlg, %WM_USER + 1000, 0, 0
   DIALOG SHOW MODAL hdefAcct, CALL createAcctProc
   enterFieldID = 0: windowNo = 0
END SUB

CALLBACK FUNCTION createAcctProc()
   LOCAL i AS LONG, n AS LONG, s AS STRING
   LOCAL s1 AS STRING, s2 AS STRING, s3 AS STRING, s4 AS STRING 
   STATIC noEdit AS BYTE, openBal AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         IF editAcct THEN
            FOR i = 1 TO numStmts
               IF stmt(i).acct = editAcct THEN
                  IF stmt(i).closed = 1 THEN noEdit = 1
               END IF
            NEXT i
            IF noEdit THEN
               MSGBOX "Cannot change balance or begining date of  " + $CRLF _
                      + "an acnCount, once a statement is reconciled  ",  , "Important Note"
               CONTROL DISABLE CBHNDL, %IDC_AcctBal
               CONTROL DISABLE CBHNDL, %IDC_AcctDate
            END IF
            selectAcctFcn = editAcct: s = acctName(editAcct)
            CONTROL SET TEXT CBHNDL, %IDC_AcctName, s
            s = FORMAT$(acct(editAcct).endBal/100, "#0.00")
            CONTROL SET TEXT CBHNDL, %IDC_AcctBal, s
            s = getDate(acct(editAcct).beginDate)
            CONTROL SET TEXT CBHNDL, %IDC_AcctDate, s
            s = acct(editAcct).acctID
            CONTROL SET TEXT CBHNDL, %IDC_AcctID, s
         END IF
         windowNo = 20: hWindow = CBHNDL: enterFieldID = %IDC_AcctOk
      CASE %WM_USER + 1000  'simulate Alt key for Windows XP
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1 
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1
      CASE %WM_COMMAND
         IF CBCTL = %IDC_AcctOk THEN
            CONTROL GET TEXT CBHNDL, %IDC_AcctName TO s1
            CONTROL GET TEXT CBHNDL, %IDC_AcctBal TO s2
            CONTROL GET TEXT CBHNDL, %IDC_AcctDate TO s3
            CONTROL GET TEXT CBHNDL, %IDC_AcctID TO s4
            IF editAcct = 0 THEN 'create new acct
               IF LEN(s1) = 0 OR LEN(s2) = 0 OR LEN(s3) = 0 THEN
                  s = "Must specify an acnCount name, balance, and date"
                  MSGBOX s, , "Create New AcnCount"
                  CONTROL SET FOCUS CBHNDL, %IDC_AcctName: EXIT FUNCTION
               END IF
               INCR numAccts: selectAcctFcn = numAccts
               REDIM PRESERVE acct(1:numAccts)
               REDIM PRESERVE acctName(numAccts)
               acct(selectAcctFcn).unused = 0
               acct(selectAcctFcn).endBal = 100 * VAL(s2)
               acct(selectAcctFcn).beginDate = storDate(s3)
            ELSEIF noEdit = 0 THEN 'can edit acct if no stmts reconciled yet
               acct(selectAcctFcn).endBal = 100 * VAL(s2)
               acct(selectAcctFcn).beginDate = storDate(s3)
               recalcBalances
            END IF
            acctName(selectAcctFcn) = s1
            acct(selectAcctFcn).acctID = s4
            fileChanged = 1 
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
         IF CBCTL >= %IDC_AcctName AND CBCTL < %IDC_AcctOk THEN
            n = CBCTL - %IDC_AcctName + 1
            IF n = 1 THEN
               s1 = "Identifying name for the acnCount"
               s2 = "... a required field"
            ELSEIF n = 2 THEN
               IF editAcct THEN s = "Ending" ELSE s = "Beginning"
               s1 = s + " balance of acnCount"
               s2 = "... a required field"
            ELSEIF n = 3 THEN
               s1 = "Date corresponding to beginning"
               s2 = "balance... a required field"
            ELSEIF n = 4 THEN
               s1 = "Bank acnCount number"
               s2 = "... optional field for info only"
            END IF
            CONTROL SET TEXT CBHNDL, -6, s1
            CONTROL SET TEXT CBHNDL, -7, s2
         END IF
   END SELECT
END FUNCTION

SUB defineStmt
   LOCAL hStmt AS LONG
   DIALOG NEW hDlg, "", , , 170, 105, %WS_SYSMENU TO hStmt
   DIALOG SET COLOR hStmt, -1, %LTGRAY
   CONTROL ADD LABEL, hStmt, -1, "Statement date:", 5, 5, 60, 10, %SS_RIGHT ', %WS_EX_STATICEDGE
   CONTROL SET COLOR hStmt, -1, -1, %LTGRAY
   CONTROL ADD LABEL, hStmt, -2, "Opening balance:", 5, 20, 60, 10, %SS_RIGHT ', %WS_EX_STATICEDGE
   CONTROL SET COLOR hStmt, -2, -1, %LTGRAY
   CONTROL ADD LABEL, hStmt, -3, "Closing balance:", 5, 35, 60, 10, %SS_RIGHT ', %WS_EX_STATICEDGE
   CONTROL SET COLOR hStmt, -3, -1, %LTGRAY
   CONTROL ADD TEXTBOX, hStmt, %IDC_StmtDate, "", 70, 5, 60, 12
   CONTROL ADD TEXTBOX, hStmt, %IDC_StmtOpenBal, "", 70, 20, 60, 12
   CONTROL ADD TEXTBOX, hStmt, %IDC_StmtCloseBal, "", 70, 35, 60, 12
   CONTROL ADD BUTTON, hStmt, %IDC_StmtOk, "&Ok", 40, 60, 40, 20
   CONTROL ADD BUTTON, hStmt, %IDCANCEL, "&Cancel", 90, 60, 40, 20
   PostMessage hDlg, %WM_USER + 1000, 0, 0
   DIALOG SHOW MODAL hStmt, CALL defineStmtProc
   enterFieldID = 0: windowNo = 0
END SUB

CALLBACK FUNCTION defineStmtProc()
   LOCAL m AS LONG, n AS LONG, i AS LONG, s AS STRING
   LOCAL mo AS LONG, yr AS LONG, day AS LONG, s1 AS STRING, s2 AS STRING, s3 AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         windowNo = 30: hWindow = CBHNDL: enterFieldID = %IDC_StmtOk
         n = %IDC_StmtCloseBal
         IF newStmt THEN 'new statement being created
            s1 = "Create new statement": newStmt = 0
            n = %IDC_StmtDate: stmtNo = 0
         ELSEIF editStmt THEN 'editing existing statement
            s1 = "Edit Statement"
            s = TRIM$(STR$(stmt(stmtNo).date))
            s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + MID$(s, 3, 2)
            CONTROL SET TEXT CBHNDL, %IDC_StmtDate, s
            s = FORMAT$(stmt(stmtNo).openBal/100, "#0.00")
            CONTROL SET TEXT CBHNDL, %IDC_StmtOpenBal, s
            s = FORMAT$(stmt(stmtNo).endBal/100, "#0.00")
            CONTROL SET TEXT CBHNDL, %IDC_StmtCloseBal, s
         ELSE 'reconciling statement
            IF reconcileMode = 0 THEN
               FOR i = numStmts TO 1 STEP -1
                  IF stmt(i).acct = acctNo THEN m = i: EXIT FOR
               NEXT i: stmtNo = 0
            END IF
            IF m THEN
               s1 = TRIM$(STR$(stmt(m).date))
               s2 = FORMAT$(stmt(m).endBal/100, "#0.00")
            ELSE
               s1 = TRIM$(STR$(acct(acctNo).beginDate))
               s2 = FORMAT$(qbal(0)/100, "#0.00")
            END IF
            IF stmtNo THEN s3 = FORMAT$(stmt(stmtNo).endBal/100, "#0.00")
            mo = VAL(MID$(s1, 5, 2)): yr = VAL(LEFT$(s1, 4)): day = VAL(RIGHT$(s1, 2))
            INCR mo: IF mo > 12 THEN mo = 1: INCR yr
            IF day >= 28 THEN day = daysInMonth(mo, yr)
            s1 = TRIM$(STR$(mo)) + "-" + TRIM$(STR$(day)) + "-" + MID$(STR$(yr), 4, 2)
            CONTROL SET TEXT CBHNDL, %IDC_StmtDate, s1
            CONTROL SET TEXT CBHNDL, %IDC_StmtOpenBal, s2
            CONTROL SET TEXT CBHNDL, %IDC_StmtCloseBal, s3
            s1 = "Reconcile statement"
         END IF
         DIALOG SET TEXT CBHNDL, s1
         CONTROL SET FOCUS CBHNDL, n
      CASE %WM_USER + 1000  'simulate Alt key for Windows XP
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1 
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDCANCEL
               DIALOG END CBHNDL
            CASE %IDC_StmtOk
               CONTROL GET TEXT CBHNDL, %IDC_StmtDate TO s: n = storDate(s)
               IF n = 0 THEN
                  MSGBOX "Must specify statement date", , "Define Statement"
                  CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
                  EXIT FUNCTION
               END IF
               IF stmtNo = 0 THEN 'create new statement in date sequence
                  INCR numStmts  
                  REDIM PRESERVE stmt(1:numStmts)
                  i = numStmts  'insert new stmt at ordered position
                  WHILE i > 1 AND stmt(i - 1).date > n
                     stmt(i) = stmt(i - 1): DECR i
                  WEND: stmtNo = i
                  FOR i = 1 TO numEntries 'adjust entry stmt references
                     IF entry(i).acct = acctNo THEN
                        IF entry(i).stmt >= stmtNo THEN INCR entry(i).stmt
                     END IF
                  NEXT i
                  stmt(stmtNo).acct = acctNo
                  stmt(stmtNo).closed = 0 'stmt marked as open
               END IF
               stmt(stmtNo).date = n: reconcileMode = 1
               CONTROL GET TEXT CBHNDL, %IDC_StmtOpenBal TO s1
               CONTROL GET TEXT CBHNDL, %IDC_StmtCloseBal TO s2
               stmt(stmtNo).openBal = 100 * VAL(s1)
               stmt(stmtNo).endBal = 100 * VAL(s2)
               getReconcileDiff
               entryNo = 1: showInit = 1: updateAcct: statusLine 1
               DIALOG END CBHNDL: fileChanged = 1
         END SELECT
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB getReconcileDiff()
   LOCAL i AS LONG, n AS LONG
   reconcileDiff = stmt(stmtNo).endBal - stmt(stmtNo).openBal
   FOR i = 1 TO numActive 
      n = active(i)
      IF entry(n).stmt = 0 AND BIT(entry(n).flag, 0) AND BIT(entry(n).flag, 4) = 0 THEN
         reconcileDiff = reconcileDiff + entry(n).amt
      END IF
   NEXT i
END SUB

SUB summary()
   LOCAL hSummary AS LONG
   DIALOG NEW hDlg, "Reconciliation Summary", , , 240, 130, %WS_SYSMENU TO hSummary
   DIALOG SET COLOR hSummary, -1, %LTGRAY
   DIALOG SHOW MODAL hSummary, CALL summaryProc
END SUB

CALLBACK FUNCTION summaryProc()
   LOCAL i AS LONG, j AS WORD, s AS STRING
   LOCAL m AS LONG, n AS LONG, ps AS PAINTSTRUCT
   LOCAL numCks AS LONG, amtCks AS LONG
   LOCAL numPay AS LONG, amtPay AS LONG
   LOCAL numDep AS LONG, amtDep AS LONG
   LOCAL numTrx AS LONG, amtTrx AS LONG
   DIM s1(8) AS STRING, s2(8) AS STRING, s3(8) AS STRING
   SELECT CASE CBMSG
      CASE %WM_PAINT
         BeginPaint CBHNDL, ps
         FOR i = 1 TO numActive
            n = active(i): m = entry(n).amt
            IF BIT(entry(n).flag, 0) OR entry(n).stmt = stmtNo THEN
               INCR numTrx: amtTrx = amtTrx + entry(n).amt
               IF m > 0 THEN
                  INCR numPay: amtPay = amtPay + m
               ELSE
                  INCR numDep: amtDep = amtDep - m
               END IF
               j = numVal(entry(n).ckNo)
               IF j THEN INCR numCks: amtCks = amtCks + m
            END IF
         NEXT i
         reconcileDiff = stmt(stmtNo).openBal + amtDep - amtPay
         reconcileDiff = reconcileDiff - stmt(stmtNo).endBal
         s1(1) = "Statement Date:"
         s1(2) = "Opening Balance:"
         s1(3) = "Closing Balance:"
         s1(4) = "Reconcile Difference:"
         s1(5) = "Total Transactions:"
         s1(6) = "Total Checks:"
         s1(7) = "Total Payments:"
         s1(8) = "Total Deposits:"
         s = TRIM$(STR$(stmt(stmtNo).date))
         s2(1) = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + MID$(s, 3, 2)
         s2(2) = FORMAT$(stmt(stmtNo).openBal/100, "#0.00")
         s2(3) = FORMAT$(stmt(stmtNo).endBal/100, "#0.00")
         s2(4) = FORMAT$(reconcileDiff/100, "#0.00")
         s2(5) = TRIM$(STR$(numTrx))
         s2(6) = TRIM$(STR$(numCks))
         s2(7) = TRIM$(STR$(numPay))
         s2(8) = TRIM$(STR$(numDep))
         s3(5) = FORMAT$(amtTrx/100, "#0.00")
         s3(6) = FORMAT$(amtCks/100, "#0.00")
         s3(7) = FORMAT$(amtPay/100, "#0.00")
         s3(8) = FORMAT$(amtDep/100, "#0.00")
         hdc = GetDc(CBHNDL)
         hFont = makeFont(hDC, "MS sans serif", 10)
         hOrigFont = SelectObject(hdc, hFont)
         SetTextColor hdc, RGB(0, 0, 0)
         SetBkColor hdc, %LTGRAY
         FOR i = 1 TO 8
            IF i <= 4 THEN m = -10 ELSE m = 5
            showText hDC, 10, m + 18*i, s1(i)
            showText hDC, 180, m + 18*i, s2(i)
            showText hDC, 270, m + 18*i, s3(i)
         NEXT i
         DeleteObject SelectObject(hdc, hOrigFont)
         ReleaseDC CBHNDL, hdc
         EndPaint CBHNDL, ps
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
      END SELECT
END FUNCTION

SUB listStmts
   LOCAL STYLE AS LONG, hStmt AS LONG, title AS STRING
   DIALOG NEW hDlg, "List of Statements", , , 245, 170, %WS_SYSMENU TO hStmt
   hWindow = hStmt
   DIALOG SET COLOR hStmt, -1, %LTGRAY
   title = "   Date" + SPACE$(20) + "Status" + SPACE$(20) + "Begin bal" + SPACE$(20) + "End bal"
   CONTROL ADD LABEL, hStmt, -1, title, 5, 5, 220, 10
   STYLE = %WS_VSCROLL OR %LBS_DISABLENOSCROLL OR %LBS_USETABSTOPS OR %WS_TABSTOP
   CONTROL ADD LISTBOX, hStmt, %IDC_Stmts, , 5, 15, 230, 100, STYLE
   CONTROL ADD BUTTON, hStmt, %IDC_NewStmt, "&New", 10, 125, 40, 20
   CONTROL ADD BUTTON, hStmt, %IDC_EditStmt, "&Edit", 55, 125, 40, 20
   CONTROL ADD BUTTON, hStmt, %IDC_DelStmt, "&Delete", 100, 125, 40, 20
   STYLE = %BS_DEFAULT OR %WS_TABSTOP
   CONTROL ADD BUTTON, hStmt, %IDC_ViewStmt, "&View", 170, 125, 60, 20, STYLE
   DIALOG SHOW MODAL hStmt, CALL listStmtsProc
END SUB

CALLBACK FUNCTION listStmtsProc
   LOCAL i AS LONG, j AS LONG, k AS LONG, n AS LONG
   LOCAL s AS STRING, sz AS ASCIIZ *64, defStmt AS INTEGER
   LOCAL s1 AS STRING, s2 AS STRING, tabstops() AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         DIM tabstops(3)
         tabstops(1) = 60
         tabstops(2) = -150
         tabstops(3) = -215
         CONTROL SEND CBHNDL, %IDC_Stmts, %LB_SETTABSTOPS, 4, VARPTR(tabstops(0))
         CONTROL SEND CBHNDL, %IDC_Stmts, %LB_RESETCONTENT, 0, 0
         defStmt = entry(active(selector)).stmt: stmtNo =0
         FOR i = 1 TO numStmts
            IF stmt(i).acct = acctNo THEN
               IF stmt(i).closed = 0 THEN s = "Open": stmtNo = i
               IF stmt(i).closed = 1 THEN s = "Closed"
               IF stmt(i).closed = 2 THEN s = "Reopened": stmtNo = i
               s1 = FORMAT$(stmt(i).openBal/100, "#0.00")
               s2 = FORMAT$(stmt(i).endBal/100, "#0.00")
               sz = getDate(stmt(i).date) + CHR$(9) + s
               sz = sz + $TAB + s1 + $TAB + s2
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_ADDSTRING, 0, VARPTR(sz) TO n
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_SETITEMDATA, n, i
               IF i = defStmt THEN j = n + 1
               IF i = stmtNo THEN k = n + 1
            END IF
         NEXT i
         windowNo = 0: IF j = 0 THEN j = k
         LISTBOX SELECT CBHNDL, %IDC_Stmts, j
         CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETITEMDATA, j - 1, 0 TO i
         IF numStmts = 0 OR i < 0 THEN
            CONTROL DISABLE CBHNDL, %IDC_EditStmt
            CONTROL DISABLE CBHNDL, %IDC_DelStmt
            CONTROL DISABLE CBHNDL, %IDC_ViewStmt
         ELSEIF stmt(i).closed = 1 THEN
            CONTROL ENABLE CBHNDL, %IDC_ViewStmt
            CONTROL DISABLE CBHNDL, %IDC_DelStmt
         END IF
         IF stmtNo THEN CONTROL DISABLE CBHNDL, %IDC_NewStmt
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_Stmts
               IF CBCTLMSG = %LBN_SELCHANGE THEN
                  CONTROL ENABLE CBHNDL, %IDC_EditStmt
                  CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETCURSEL, 0, 0 TO n
                  CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETITEMDATA, n, 0 TO i
                  IF stmt(i).closed = 1 THEN
                     CONTROL ENABLE CBHNDL, %IDC_ViewStmt
                     CONTROL DISABLE CBHNDL, %IDC_DelStmt
                  ELSE
                     CONTROL ENABLE CBHNDL, %IDC_DelStmt
                  END IF
               ELSEIF CBCTLMSG = %LBN_DBLCLK THEN
                  DIALOG SEND CBHNDL, %WM_COMMAND, %IDC_ViewStmt, 0
               END IF
            CASE %IDC_NewStmt
               IF stmtNo THEN
                  s = "For any acnCount, only one statement at a time can be open" 
                  MSGBOX s, %MB_ICONERROR, "New Statement": EXIT FUNCTION
               END IF
               DIALOG END CBHNDL
               newStmt = 1: defineStmt: newStmt = 0
            CASE %IDC_EditStmt
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETITEMDATA, n, 0 TO i
               IF stmtNo AND stmtNo <> i THEN 
                  s = "For any acnCount, only one statement at a time can be open" 
                  MSGBOX s, %MB_ICONERROR, "Edit Statement": EXIT FUNCTION
               END IF
               IF stmt(i).closed = 1 THEN
                  s = "Do you really need to reopen this statement?"
                  n = MSGBOX($CRLF + s + $CRLF + $CRLF, %MB_YESNO + %MB_ICONQUESTION, _
                               "WARNING - Closed Statement")
                  IF n = %IDNO THEN EXIT FUNCTION
               END IF
               stmtNo = i
               IF stmt(stmtNo).closed = 1 THEN 
                  stmt(stmtNo).closed = 2 'reopened 
                  fileChanged = 1: viewStmtMode = 0
                  FOR i = 1 TO numEntries
                     IF entry(i).stmt = stmtNo THEN
                        entry(i).stmt = 0: BIT SET entry(i).flag, 0
                     END IF
                  NEXT i
               END IF
               DIALOG END CBHNDL
               editStmt = 1: defineStmt
            CASE %IDC_DelStmt
               s = "Are you absolutely sure that you" + $CRLF _
                 + "want to delete this statement?"
               n = MSGBOX(s, %MB_ICONERROR OR %MB_YESNO, "Delete Statement")
               IF n = %IDYES THEN 'delete statement
                  CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETCURSEL, 0, 0 TO n
                  CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETITEMDATA, n, 0 TO n
                  fileChanged = 1
                  IF stmtNo = n THEN stmtNo = 0: reconcileMode = 0: statusLine 1
                  ARRAY DELETE stmt(n): DECR numStmts
                  FOR i = 1 TO numEntries
                     IF entry(i).stmt > n THEN DECR entry(i).stmt
                     IF entry(i).acct = acctNo THEN
                        IF entry(i).stmt = 0 THEN BIT RESET entry(i).flag, 0
                     END IF
                  NEXT i
                  DIALOG END CBHNDL 
                  reconcileMode = 0: setMenuState: updateAcct
               END IF
            CASE %IDC_ViewStmt
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETCURSEL, 0, 0 TO n
               CONTROL SEND CBHNDL, %IDC_Stmts, %LB_GETITEMDATA, n, 0 TO i
               DIALOG END CBHNDL
               viewStmtMode = i: reconcileMode = 0
               entryNo = 0: updateAcct: statusLine 1
               disableEntryMode 1
         END SELECT
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB disableEntryMode(n AS LONG)
   LOCAL i AS LONG, k AS LONG
   IF n THEN k = %MF_GRAYED ELSE k = %MF_ENABLED
   FOR i = %IDC_AddDate TO %IDC_ChgBtn
      CONTROL ENABLE hDlg, i
      IF n THEN CONTROL DISABLE hDlg, i
   NEXT i
   FOR i = %IDM_EDIT_ADDENTRY TO %IDM_EDIT_CHGGROUP
      MENU SET STATE hMenu, BYCMD i, k
   NEXT i
   MENU SET STATE hMenu, BYCMD %IDM_VIEW_ENTRY, k
END SUB

SUB findRecord
   LOCAL STYLE AS LONG, i AS LONG, hFind AS LONG 
   DIALOG NEW hDlg, "Find Entries", , , 150, 170, %WS_SYSMENU TO hFind
   DIALOG SET COLOR hFind, -1, %LTGRAY
   CONTROL ADD FRAME, hFind, -1, "", 10, 5, 120, 40
   CONTROL ADD OPTION, hFind, %IDC_ThisAcct, "&Search this acnCount/group", 15, 15, 100, 12, %WS_GROUP
   CONTROL ADD OPTION, hFind, %IDC_AllAccts, "Search &all acnCounts", 15, 27, 100, 12
   CONTROL SET CHECK hFind, %IDC_ThisAcct, 1
   CONTROL ADD FRAME, hFind, -1, "", 10, 50, 120, 60
   STYLE = %WS_DISABLED OR %WS_TABSTOP
   CONTROL ADD OPTION, hFind, %IDC_Partial, "&Partial match", 15, 60, 100, 12, STYLE OR %WS_GROUP
   CONTROL ADD OPTION, hFind, %IDC_Exact, "&Exact match", 15, 72, 100, 12, %WS_TABSTOP
   CONTROL ADD OPTION, hFind, %IDC_Greater, "&Greater than or equal", 15, 84, 100, 12, STYLE
   CONTROL ADD OPTION, hFind, %IDC_Less, "&Less than or equal", 15, 96, 100, 12, STYLE
   CONTROL SET CHECK hFind, %IDC_Exact, 1
   FOR i = %IDC_ThisAcct TO %IDC_Less
      CONTROL SET COLOR hFind, i, %BLACK, %LTGRAY
   NEXT i
   STYLE = %BS_DEFAULT OR %WS_TABSTOP OR %WS_GROUP
   CONTROL ADD BUTTON, hFind, %IDC_FindOk, "&Ok", 50, 120, 50, 20, STYLE
   DIALOG SHOW MODAL hFind, CALL findProc
END SUB

CALLBACK FUNCTION findProc()
   LOCAL m AS LONG, n AS LONG, i AS LONG, k AS LONG
   LOCAL srch AS LONG, ok AS LONG, s AS STRING, ss AS STRING
   STATIC findSpec AS STRING, fieldNo AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         fieldNo = 0
         FOR i = 0 TO 7 'check if a single srch field is specified
            CONTROL GET TEXT hDlg, %IDC_AddDate + i TO s
            s = LCASE$(TRIM$(s))
            IF LEN(s) THEN
               IF fieldNo THEN fieldNo = 0: EXIT FOR
               fieldNo = i + 1: findSpec = TRIM$(LCASE$(s))
               IF fieldNo = 4 OR fieldNo = 5 THEN
                  findSpec = FORMAT$(VAL(s), "#0.00")
               END IF
            END IF
         NEXT i
         IF fieldNo = 0 THEN 
            MSGBOX "Must have a single search field specified", ,"Find Error"
            DIALOG END CBHNDL: dlgResult = 1: EXIT FUNCTION
         END IF
         IF fieldNo = 1 AND NOT validDate(findSpec) THEN
            MSGBOX "Not valid date", , "Find Entries"
            DIALOG END CBHNDL: dlgResult = 1: EXIT FUNCTION
         END IF
         IF fieldNo = 3 OR fieldNo = 6 THEN
            CONTROL ENABLE CBHNDL, %IDC_Partial
            CONTROL SET CHECK CBHNDL, %IDC_Partial, 1
            CONTROL SET CHECK CBHNDL, %IDC_Exact, 0
         ELSEIF fieldNo = 1 OR fieldNo = 2 OR fieldNo = 4 OR fieldNo = 5 THEN
            CONTROL ENABLE CBHNDL, %IDC_Greater
            CONTROL ENABLE CBHNDL, %IDC_Less
         END IF
      CASE %WM_COMMAND
         CONTROL GET CHECK CBHNDL, %IDC_ThisAcct TO m
         FOR i = 0 TO 3 'find which of 4 options is selected
            CONTROL GET CHECK CBHNDL, %IDC_Partial + i TO n
            IF n THEN n = i: EXIT FOR
         NEXT i
         FOR i = 1 TO numEntries 'remove all previous selected
            BIT RESET entry(i).flag, 2
         NEXT i
         ss = findSpec
         IF fieldNo = 1 THEN ss = STR$(storDate(ss))
         amtSelected = 0
         FOR i = 1 TO numEntries  'srch
            IF m THEN k = active(i) ELSE k = i
            IF k = 0 THEN ITERATE 
            getFields k: ok = 0: s = LCASE$(fields(fieldNo - 1))
            IF fieldNo = 1 THEN s = STR$(storDate(fields(0)))
            IF n = 0 THEN
               ok = INSTR(s, ss)
            ELSEIF n = 1 THEN
               ok = (s = ss)
            ELSEIF n = 2 THEN
               ok = (VAL(s) >= VAL(ss))
            ELSE
               ok = (VAL(s) <= VAL(ss))
            END IF
            IF ok THEN 
               BIT SET entry(k).flag, 2: INCR numSelected 
               amtSelected = amtSelected + entry(k).amt: grpFound = 1
            END IF 
         NEXT i
         DIALOG END CBHNDL
         IF grpFound THEN
            MENU SET STATE hMenu, BYCMD %IDM_REC_BEGIN, %MF_GRAYED
            s = "&Back to register" + $TAB + "Ctrl + B"
            MENU SET TEXT hMenu, BYCMD %IDM_EDIT_FINDENTRY, s
         ELSE
            MSGBOX "No matching records found", , "Find Records"
         END IF 
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB findPayee
   LOCAL hPayee AS LONG, STYLE AS LONG
   DIALOG NEW hDlg, "List of Payees", , , 185, 150, %WS_SYSMENU TO hPayee
   STYLE = %LBS_DISABLENOSCROLL OR %WS_VSCROLL OR %WS_TABSTOP OR %LBS_NOTIFY
   CONTROL ADD LISTBOX, hPayee, %IDC_PayeeLB, , 5, 5, 170, 90, STYLE 
   CONTROL ADD BUTTON, hPayee, %IDOK, "&Ok", 25, 100, 60, 25, %BS_DEFAULT OR %WS_TABSTOP
   CONTROL ADD BUTTON, hPayee, %IDCANCEL, "&Cancel", 90, 100, 60, 25
   DIALOG SHOW MODAL hPayee, CALL findPayeeProc
END SUB

CALLBACK FUNCTION findPayeeProc()
   LOCAL i AS LONG, s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL GET TEXT hDlg, %IDC_AddPayee TO s
         s = TRIM$(s): grpFound = 0: windowNo = 2
         LISTBOX RESET CBHNDL, %IDC_PayeeLB 
         FOR i = 1 TO numPayees
            IF INSTR(payee(i), s) THEN LISTBOX ADD CBHNDL, %IDC_PayeeLB, payee(i)
         NEXT i
         LISTBOX SELECT CBHNDL, %IDC_PayeeLB, 1
      CASE %WM_COMMAND
         IF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDOK OR _
            (CBCTL = %IDC_PayeeLB AND CBCTLMSG = %LBN_DBLCLK) THEN
            LISTBOX GET TEXT CBHNDL, %IDC_PayeeLB TO s
            CONTROL SET TEXT hDlg, %IDC_AddPayee, s
            DIALOG END CBHNDL: CONTROL SET FOCUS hDlg, %IDC_AddPayee
         END IF
   END SELECT
END FUNCTION

SUB listCatgs()
   LOCAL STYLE AS LONG, s AS STRING
   DIALOG NEW hDlg, "List of Categories", , , 338, 290, %WS_SYSMENU TO hCatg 
   hWindow = hCatg
   DIALOG SET COLOR hCatg, -1, %LTGRAY
   STYLE = %WS_VSCROLL + %LBS_DISABLENOSCROLL + %LBS_USETABSTOPS + %WS_TABSTOP
   CONTROL ADD LISTBOX, hCatg, %IDC_Categories, , 5, 15, 325, 225, STYLE
   CONTROL ADD LABEL, hCatg, -1, "   Category", 5, 5, 120, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hCatg, -1, "  Exp/Income", 125, 5, 50, 10, %SS_LEFT, %WS_EX_STATICEDGE
   s = "    Tax form, line ID"
   CONTROL ADD LABEL, hCatg, -1, s, 175, 5, 95, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hCatg, -1, "   Budget", 270, 5, 50, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD BUTTON, hCatg, %IDC_NewCatg, "New", 30, 245, 40, 20
   CONTROL ADD BUTTON, hCatg, %IDC_EditCatg, "Edit", 70, 245, 40, 20
   CONTROL ADD BUTTON, hCatg, %IDC_DelCatg, "Del", 110, 245, 40, 20
   CONTROL ADD BUTTON, hCatg, %IDCANCEL, "Cancel", 180, 245, 50, 20
   DIALOG SHOW MODAL hCatg, CALL listCatgsProc
END SUB                                      

CALLBACK FUNCTION listCatgsProc()
   LOCAL i AS LONG, m AS LONG, n AS LONG, s AS STRING
   LOCAL first AS LONG, last AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         catgNo = 0: listCatgItems
      CASE %WM_COMMAND
         SELECT CASE CBCTL
            CASE %IDC_NewCatg
               editCatg = 0: defineCatg: listCatgItems: updateScrn
            CASE %IDC_EditCatg
               editCatg = 1: defineCatg: listCatgItems
            CASE %IDC_DelCatg
               CONTROL SEND CBHNDL, %IDC_Categories, %LB_GETCURSEL, 0, 0 TO m
               IF m < 0 THEN EXIT FUNCTION
               n = m + 1: first = n
               IF catg(n).Subcatg THEN
                  first = n: last = n: s = "subcategory"
               ELSE  
                  first = n - catg(n).Subcatg: s = "category"
                  IF catg(n + 1).Subcatg THEN s = s + " and its subcategories"
                  last = first + 1: WHILE catg(last).Subcatg: INCR last: WEND: DECR last
               END IF 
               s = "Delete this " + s + " now?" 
               m = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Delete Category")
               IF m = %IDNO THEN EXIT FUNCTION 
               n = 0
               FOR i = 1 TO numEntries 'check if any are in use
                  'IF BIT(entry(i).flag, 6) THEN ITERATE
                  'IF BIT(entry(i).flag, 7) THEN ITERATE
                  m = entry(i).catg
                  IF BIT(entry(i).flag, 7) THEN 'split
                     
                  END IF 
                  IF entry(i).flag >= 8 THEN ITERATE 'void, deleted, transfer 
                  IF m >= first AND m <= last THEN n = i: EXIT FOR
               NEXT i
               IF n THEN 
                  s = "Category in use... must remove from entries first"
                  n = MSGBOX(s, %MB_ICONINFORMATION, "Delete Category")
                  EXIT FUNCTION
               END IF
               FOR i = first TO last
                  deleteCatg CWRD(first) 
               NEXT i
               catgNo = first: listCatgItems: fileChanged = 1
            CASE %IDCANCEL
               DIALOG END CBHNDL
         END SELECT
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB listCatgItems()
   LOCAL i AS LONG, m AS LONG, n AS LONG, lptr AS LONG, s AS STRING
   LOCAL sCatg AS STRING, sSubcatg AS STRING, sTax AS STRING, sBudget AS STRING
   REDIM tabstops(4) AS LONG
   tabstops(1) = 5
   tabstops(2) = 125
   tabstops(3) = 175
   tabstops(4) = 275
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hCatg, %IDC_Categories, %LB_SETTABSTOPS, 5, lptr
   LISTBOX RESET hCatg, %IDC_Categories
   FOR i = 1 TO numCatgs
      n = catg(i).subcatg: IF n THEN sSubcatg = "- " + catgName(i)
      m = i - n: sCatg = catgName(m)
      m = catg(i).taxRef: sTax = tax(m)
      IF catg(i).Budget THEN sBudget = STR$(catg(i).Budget) ELSE sBudget = ""
      IF catg(i).income THEN s = "Income" ELSE s = "Expense"
      IF n THEN
         s = $TAB + sSubcatg + $TAB + s + $TAB + sTax + $TAB + sBudget
      ELSE
         s = sCatg + $TAB + s + $TAB + sTax + $TAB + sBudget 
      END IF
      LISTBOX ADD hCatg,%IDC_Categories, s
   NEXT i
   IF catgNo = 0 THEN catgNo = 1
   LISTBOX SELECT hCatg, %IDC_Categories, catgNo
   CONTROL SET FOCUS hCatg, %IDC_Categories
END SUB

SUB defineCatg()
   'define a category or subcategory as expense or income
   'include tax and budget attributes if applicable
   LOCAL STYLE AS LONG, s AS STRING
   IF editCatg THEN s = "Edit" ELSE s = "Define"
   DIALOG NEW hDlg, s + " Category", 20, 60, 260, 140, %WS_SYSMENU TO hdefCatg
   DIALOG SET COLOR hdefCatg, -1, %LTGRAY
   CONTROL ADD LABEL, hdefCatg, -1, "Category:", 5, 5, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefCatg, -1, -1, %LTGRAY
   CONTROL ADD LABEL, hdefCatg, -2, " Subcategory:", 5, 20, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefCatg, -2, -1, %LTGRAY
   CONTROL ADD LABEL, hdefCatg, -3, "Income tax ID:", 5, 35, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefCatg, -3, -1, %LTGRAY
   CONTROL ADD LABEL, hdefCatg, -4, "Budget (dollars):", 5, 50, 70, 10, %SS_RIGHT
   CONTROL SET COLOR hdefCatg, -4, -1, %LTGRAY
   STYLE = %CBS_DROPDOWN OR %WS_TABSTOP OR %WS_VSCROLL
   CONTROL ADD COMBOBOX, hdefCatg, %IDC_DefCatg, , 80, 5, 120, 70, STYLE
   IF editCatg THEN
      CONTROL ADD COMBOBOX, hdefCatg, %IDC_DefSubcatg, , 80, 20, 120, 60, STYLE
   ELSE
      CONTROL ADD TEXTBOX, hdefCatg, %IDC_DefSubcatg, "", 80, 20, 120, 12
   END IF
   CONTROL ADD COMBOBOX, hdefCatg, %IDC_DefCatgTax, tax(), 80, 35, 120, 60, STYLE 
   CONTROL ADD TEXTBOX, hdefCatg, %IDC_DefCatgBudget, "", 80, 50, 120, 12
   s = "Income (otherwise, expense)"
   CONTROL ADD CHECKBOX, hdefCatg, %IDC_DefCatgIncome, s, 80, 70, 120, 12
   CONTROL ADD BUTTON, hdefCatg, %IDC_DefCatgOk, "&Ok", 155, 90, 40, 20
   CONTROL ADD BUTTON, hdefCatg, %IDCANCEL, "&Cancel", 200, 90, 40, 20
   CONTROL SET COLOR hdefCatg, %IDC_DefCatgIncome, -1, %LTGRAY
   CONTROL ADD FRAME, hdefCatg, -5, "", 10, 85, 130, 32
   CONTROL ADD LABEL, hdefCatg, -6, "Identifying name for the category", 15, 92, 115, 10
   CONTROL SET COLOR hdefCatg, -6, -1, %LTGRAY
   CONTROL ADD LABEL, hdefCatg, -7, "", 15, 102, 115, 10
   CONTROL SET COLOR hdefCatg, -7, -1, %LTGRAY
   PostMessage hDlg, %WM_USER + 1000, 0, 0
   DIALOG SHOW MODAL hdefCatg, CALL defineCatgProc
   enterFieldID = 0: windowNo = 0
END SUB

CALLBACK FUNCTION defineCatgProc()
   LOCAL s AS STRING, ss AS STRING  ', s1 AS STRING, s2 AS STRING  ', s3 AS STRING, s4 AS STRING
   LOCAL sz1 AS ASCIIZ*48, sz2 AS ASCIIZ*48, sz3 AS ASCIIZ*48, sz4 AS ASCIIZ*48
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL ii AS LONG, jj AS LONG, STYLE AS LONG, temp AS catgData
   STATIC ssz1 AS ASCIIZ*64, ssz2 AS ASCIIZ*64, income AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         enterFieldID = %IDC_DefCatgOk
         CONTROL SEND hCatg, %IDC_Categories, %LB_GETCURSEL, 0, 0 TO m
         IF m < 0 THEN DIALOG END CBHNDL: EXIT FUNCTION
         catgNo = m + 1: resetTaxList
         CONTROL GET CHECK CBHNDL, %IDC_DefCatgIncome TO income
         resetCatgList income, CBHNDL, %IDC_DefCatg: 
         sz1 = catgName(catgNo): m = catg(catgNo).subcatg 
         IF m THEN sz2 = sz1: n = catgNo - m: sz1 = catgName(n)
         IF editCatg THEN
            IF catg(catgNo).Subcatg THEN
               CONTROL DISABLE CBHNDL, %IDC_DefCatg 
               n = catgNo - catg(catgNo).Subcatg
               resetSubcatgList n, CBHNDL, %IDC_DefSubcatg
            ELSEIF catg(catgNo).Subcatg = 0 THEN
               CONTROL DISABLE CBHNDL, %IDC_DefSubcatg
            END IF
            CONTROL SET TEXT CBHNDL, %IDC_DefCatg, sz1
            CONTROL SET TEXT CBHNDL, %IDC_DefSubcatg, sz2
            IF catg(catgNo).taxRef THEN sz3 = tax(catg(catgNo).taxRef)
            IF catg(catgNo).budget THEN sz4 = TRIM$(STR$(catg(catgNo).budget))
            CONTROL SET TEXT CBHNDL, %IDC_DefCatgTax, sz3
            CONTROL SET TEXT CBHNDL, %IDC_DefCatgBudget, sz4
            income = catg(catgNo).income: ssz1 = sz1: ssz2 = sz2
            CONTROL SET CHECK CBHNDL, %IDC_DefCatgIncome, income
            CONTROL DISABLE CBHNDL, %IDC_DefCatgIncome
         END IF
         windowNo = 40: hWindow = CBHNDL: enterFieldID = %IDC_DefCatgOk
      CASE %WM_USER + 1000  'simulate Alt key for Windows XP
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1 
         KeyBd_Event %VK_MENU, 0, 0, 0: SLEEP 1                
         KeyBd_Event %VK_MENU, 0, %KEYEVENTF_KEYUP, 0: SLEEP 1
      CASE %WM_COMMAND 
         IF CBCTL = %IDC_DefCatgIncome THEN
            CONTROL GET CHECK CBHNDL, CBCTL TO income
            resetCatgList income, CBHNDL, %IDC_DefCatg
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDC_DefCatgOk THEN
            CONTROL GET TEXT CBHNDL, %IDC_DefCatg TO sz1
            CONTROL GET TEXT CBHNDL, %IDC_DefSubcatg TO sz2
            CONTROL SEND CBHNDL, %IDC_DefCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz1) TO n
            CONTROL SEND CBHNDL, %IDC_DefSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz2) TO m
            INCR m: INCR n: 
            IF LEN(sz1) = 0 THEN 
               CONTROL SET FOCUS CBHNDL, %IDC_DefCatg: EXIT FUNCTION
            END IF
            IF editCatg THEN
               IF catg(catgNo).Subcatg AND sz2 <> ssz2 THEN 'subcatg has changed
                  IF LEN(sz2) = 0 THEN EXIT FUNCTION
                  catgName(catgNo) = sz2
                  m = catgNo - catg(catgNo).Subcatg: k = getNumSubcatgs(m): s = sz2
                  ARRAY SCAN catgName(m + 1) FOR k, COLLATE UCASE, > s, TO i
                  IF i = 0 THEN i = k + 1 
                  n = m + i
                  IF n <> catgNo THEN 'move subcatg
                     temp = catg(catgNo)
                     IF n > catgNo THEN
                        ARRAY DELETE catg(catgNo) FOR n - catgNo, temp    
                        ARRAY DELETE catgName(catgNo) FOR n - catgNo, sz2
                     ELSE
                        ARRAY INSERT catg(n) FOR catgNo - n + 1, temp
                        ARRAY INSERT catgName(n) FOR catgNo - n + 1, sz2
                     END IF
                     FOR i = 1 TO k
                        catg(m + i).Subcatg = i
                     NEXT i
                     correctEntryCatgs n, SGN(catgNo - n): catgNo = n
                  END IF     
               ELSEIF catg(CatgNo).Subcatg = 0 AND sz1 <> ssz1 THEN 'parent catg has changed
                  catgName(catgNo) = sz1
                  m = catgNo - catg(catgNo).Subcatg: k = getNumSubcatgs(m)
                  s = UCASE$(sz1): ii = 1: jj = numExpenses
                  IF catg(catgNo).income THEN ii = numExpenses + 1: jj = numCatgs
                  IF income THEN n = numCatgs + 1 ELSE n = numExpenses + 1
                  FOR i = ii TO jj
                     IF catg(i).Subcatg THEN ITERATE
                     IF UCASE$(catgName(i)) > s THEN n = i: EXIT FOR
                  NEXT i
                  IF n <> catgNo THEN 'move parent catg
                     FOR i = 0 TO k
                        IF n > catgNo THEN
                           temp = catg(catgNo) 
                           IF i THEN s = catgName(catgNo) ELSE s = sz1
                           ARRAY DELETE catg(catgNo) FOR n - catgNo, temp    
                           ARRAY DELETE catgName(catgNo) FOR n - catgNo, s
                        ELSE
                           temp = catg(catgNo + k) 
                           IF i < k THEN s = catgName(catgNo + k) ELSE s = sz1
                           ARRAY INSERT catg(n) FOR catgNo + k - n + 1, temp
                           ARRAY INSERT catgName(n) FOR catgNo + k - n + 1, s
                        END IF
                     NEXT i
                     correctEntryCatgs n, SGN(catgNo - n)*(k + 1): catgNo = n
                  END IF
               END IF
            ELSE
               s = sz1: ss = sz2: catgNo = newCatg(s, ss) 
            END IF
            CONTROL GET CHECK CBHNDL, %IDC_DefCatgIncome TO n
            catg(catgNo).income = n: n = catg(catgNo).taxRef: ss = tax(n)
            CONTROL GET TEXT CBHNDL, %IDC_DefCatgTax TO sz3
            CONTROL GET TEXT CBHNDL, %IDC_DefCatgBudget TO sz4
            CONTROL SEND CBHNDL, %IDC_DefCatgTax, %CB_FINDSTRINGEXACT, -1, VARPTR(sz3) TO k
            INCR k: m = k
            IF m = 0 AND LEN(ss) THEN                                      
               s = "Make this change for all categories with the same reference?"
               k = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Changing Tax ID")
               IF k = %IDNO THEN ss = ""
            END IF
            IF m = 0 AND LEN(sz3) AND LEN(ss) = 0 THEN 'defining new tax ID 
               DIM temp(numTaxes) AS LONG 'search for an unused tax() entry 
               FOR i = 1 TO numCatgs
                  j = catg(i).taxRef: IF j THEN temp(j) = 1
               NEXT i
               m = 0 
               FOR i = 1 TO numTaxes
                  IF temp(i) = 0 THEN m = i: EXIT FOR
               NEXT i
               IF m = 0 THEN 'all tax() entries in use  
                  INCR numTaxes: REDIM PRESERVE tax(numTaxes)
                  resetTaxList: m = numTaxes
               END IF
            ELSEIF m = 0 AND LEN(ss) THEN 'editing an existing tax ID
               m = n
            END IF
            catg(catgNo).taxRef = m: tax(m) = sz3
            catg(catgNo).budget = VAL(sz4)
            DIALOG END CBHNDL
         END IF
         IF CBCTL >= %IDC_DefCatg AND CBCTL <= %IDC_DefCatgBudget THEN
            n = CBCTL - %IDC_DefCatg + 1
            IF n = 1 THEN
               s = "Identifying name for the category"
               ss = "... a required field"
            ELSEIF n = 2 THEN
               s = " identifying name for a sub category"
               ss = "... required unless defining category"
            ELSEIF n = 3 THEN
               s = "income tax target for this catg"
               ss = "... optional field, [schd, line]"
            ELSEIF n = 4 THEN
               s = "monthly budget for this catg"
               ss = "... optional field, [dollar value]"
            END IF
            CONTROL SET TEXT CBHNDL, -6, s
            CONTROL SET TEXT CBHNDL, -7, ss
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

FUNCTION getNumSubcatgs(ncatg AS LONG) AS LONG
   LOCAL i AS LONG
   i = ncatg + 1 
   WHILE i <= numCatgs AND catg(i).Subcatg: INCR i: WEND
   FUNCTION = i - ncatg - 1
END FUNCTION

SUB correctEntryCatgs(BYVAL n AS LONG, k AS LONG)
   'catgNo is the original catg, n is the new
   'k is the category increment
   LOCAL i AS LONG, j AS LONG, m AS LONG, ii AS LONG, jj AS LONG
   ii = MIN(catgNo, n): jj = MAX(catgNo, n)
   IF n < catgNo THEN DECR n
   FOR i = 1 TO numEntries 
      m = entry(i).catg: j = ABS(k) - 1
      IF BIT(entry(i).flag, 7) THEN 'entry with split
         editMode = i: getSplitItems
         FOR j = 1 TO numSplitItems
            m = splitItem(j).catg
            IF m >= catgNo AND m <= catgNo + j THEN 
               splitItem(j).catg = n + m - catgNo + k
            ELSEIF m >= ii AND m <= jj THEN
               splitItem(j).catg = m + k
            END IF
         NEXT j
         editMode = 0: setSplitItems
         split(entry(i).catg) = splitStr
      ELSEIF m >= catgNo AND m <= catgNo + j THEN
         entry(i).catg = n + m - catgNo + k
      ELSEIF m >= ii AND m <= jj THEN
         entry(i).catg = m + k
      END IF
   NEXT i
END SUB

FUNCTION newCatg(sCatg AS STRING, sSubcatg AS STRING) AS WORD
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL ii AS LONG, jj AS LONG, income AS LONG, s AS STRING
   LOCAL sz AS ASCIIZ*64, tempCatg AS catgData
   CONTROL GET CHECK hDefCatg, %IDC_DefCatgIncome TO income: sz = sCatg
   CONTROL SEND hDefCatg, %IDC_DefCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m
   CONTROL SEND hDefCatg, %IDC_DefCatg, %CB_GETITEMDATA, m, 0 TO n
   IF m >= 0 THEN 'already defined catg, now define new subCatg
      IF LEN(sSubcatg) = 0 THEN EXIT FUNCTION
      s = UCASE$(sSubcatg): j = getNumSubcatgs(n)
      IF j THEN ARRAY SCAN catgName(n + 1) FOR j, COLLATE UCASE, > s, TO i
      IF i = 0 THEN i = j + 1
      k = n + i: INCR numCatgs
      REDIM PRESERVE catg(1:numCatgs)
      REDIM PRESERVE catgName(numCatgs)
      ARRAY INSERT catg(k), tempCatg
      ARRAY INSERT catgName(k), sSubCatg
      FOR i = 1 TO j + 1
         catg(n + i).Subcatg = i
      NEXT i
   ELSE 'new parent catg
      ii = 1: jj = numExpenses: k = numExpenses: s = UCASE$(sCatg)
      IF income THEN ii = numExpenses + 1: jj = numCatgs: k = numCatgs
      FOR i = ii TO jj
         IF catg(i).Subcatg THEN ITERATE
         IF s < UCASE$(catgName(i)) THEN k = i: EXIT FOR
      NEXT i
      INCR numCatgs
      REDIM PRESERVE catg(1:numCatgs)
      REDIM PRESERVE catgName(numCatgs)
      tempCatg.subcatg = 0: j = 1
      ARRAY INSERT catg(k), tempCatg
      ARRAY INSERT catgName(k), sCatg
      IF LEN(sSubcatg) THEN 'define first new subcatg
         INCR numCatgs: INCR k
         REDIM PRESERVE catg(1:numCatgs)
         REDIM PRESERVE catgName(numCatgs)
         tempCatg.subcatg = 1: j = 2
         ARRAY INSERT catg(k), tempCatg
         ARRAY INSERT catgName(k), sSubcatg
      END IF
   END IF
   IF income = 0 THEN INCR numExpenses
   FOR i = 1 TO numEntries
      IF BIT(entry(i).flag, 7) THEN
         editMode = i: getsplitItems
         FOR m = 1 TO numSplitItems
            IF splitItem(m).catg >= k THEN 
               splitItem(m).catg = splitItem(m).catg + j
            END IF
         NEXT m
         setsplitItems
      ELSEIF entry(i).catg >= k THEN 
         INCR entry(i).catg
      END IF
   NEXT i
   editMode = 0
   FUNCTION = k
END FUNCTION

SUB deleteCatg(w AS WORD)
   LOCAL i AS LONG
   i = w 'first, update subcatgs
   WHILE catg(i).subcatg
      DECR catg(i).subcatg: INCR i
   WEND
   ARRAY DELETE catg(w)
   ARRAY DELETE catgName(w)
   FOR i = 1 TO numEntries
      IF entry(i).catg > w THEN
         DECR entry(i).catg
      ELSEIF entry(i).catg = w THEN
         entry(i).catg = 0
      END IF
   NEXT i
   DECR numCatgs
END SUB

SUB resetTaxList()
   LOCAL i AS LONG
   COMBOBOX RESET hdefCatg, %IDC_DefCatgTax
   FOR i = 1 TO numTaxes
      COMBOBOX ADD hdefCatg, %IDC_DefCatgTax, tax(i)
   NEXT i
END SUB

SUB processSplit()
   LOCAL nStyle AS LONG, s AS STRING
   s = "Split Transaction"
   IF splitOpt THEN s = "Process " + s + " Items"
   DIALOG NEW hDlg, s, , , 320, 170, %WS_SYSMENU TO hSplit
   DIALOG SET COLOR hSplit, -1, %LTGRAY
   nStyle = %WS_VSCROLL + %LBS_DISABLENOSCROLL + %LBS_USETABSTOPS + %WS_TABSTOP
   CONTROL ADD LISTBOX, hSplit, %IDC_SplitItems, , 5, 15, 305, 100, nStyle
   CONTROL ADD LABEL, hSplit, -1, "   Category", 5, 5, 75, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hSplit, -1, "   Subcategory", 80, 5, 75, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hSplit, -1, "  Description", 155, 5, 100, 10, %SS_LEFT, %WS_EX_STATICEDGE
   CONTROL ADD LABEL, hSplit, -1, "    Amount", 255, 5, 45, 10, %SS_LEFT, %WS_EX_STATICEDGE
   IF splitOpt THEN
      CONTROL ADD BUTTON, hSplit, %IDC_AddItem, "Add", 30, 120, 40, 20
      CONTROL ADD BUTTON, hSplit, %IDC_EditItem, "Edit", 70, 120, 40, 20
      CONTROL ADD BUTTON, hSplit, %IDC_DelItem, "Del", 110, 120, 40, 20
      CONTROL ADD BUTTON, hSplit, %IDC_SplitOk, "Ok", 170, 120, 50, 20
   END IF
   CONTROL ADD BUTTON, hSplit, %IDCANCEL, "Cancel", 220, 120, 50, 20
   DIALOG SHOW MODAL hSplit, CALL processSplitProc
   splitOpt = 0
END SUB

CALLBACK FUNCTION processSplitProc()
   LOCAL i AS LONG, n AS LONG, s AS STRING 
   STATIC savEditMode AS WORD
   STATIC savSplitStr AS STRING
   STATIC savNumSplitItems AS BYTE
   STATIC savSplitOpt AS BYTE
   STATIC savSplitItem() AS splitData
   STATIC savSplitDescr() AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL GET TEXT hDlg, %IDC_AddPay TO s
         IF LEN(s) = 0 THEN CONTROL GET TEXT hDlg, %IDC_AddDep TO s
         splitAmt = VAL(s) * 100
         IF windowNo = 0 AND numSplitItems THEN 'view split
            DIM savSplitItem(numSplitItems)
            DIM savSplitDescr(numSplitItems)
            savEditMode = editMode: editMode = 0
            savSplitStr = splitStr
            savNumSplitItems = numSplitItems
            savSplitOpt = splitOpt: splitOpt = 0
            FOR i = 1 TO numSplitItems
               savSplitItem(i) = splitItem(i)
               savSplitDescr(i) = splitDescr(i)
            NEXT i
         END IF
         IF splitOpt < 2 THEN itemNo = 1: getSplitItems 
         listSplitItems: IF splitOpt = 0 THEN numSplitItems = 0
      CASE %WM_COMMAND
         IF CBCTL = %IDC_AddItem AND splitOpt THEN
            editItem = 0: defineSplitItem: listSplitItems: windowNo = 8
         ELSEIF CBCTL = %IDC_EditItem AND splitOpt THEN
            CONTROL SEND CBHNDL, %IDC_SplitItems, %LB_GETCURSEL, 0, 0 TO i
            editItem = i + 1: defineSplitItem: listSplitItems: windowNo = 8
         ELSEIF CBCTL = %IDC_DelItem AND splitOpt THEN
            CONTROL SEND CBHNDL, %IDC_SplitItems, %LB_GETCURSEL, 0, 0 TO i
            itemNo = i + 1: s = "Delete this split item now?"
            n = MSGBOX(s, %MB_YESNO + %MB_ICONQUESTION, "Delete Split Item")
            IF n = %IDYES THEN
               ARRAY DELETE splitItem(itemNo)
               ARRAY DELETE splitDescr(itemNo)
               DECR numSplitItems
               listSplitItems
            END IF
         ELSEIF CBCTL = %IDC_SplitOk AND splitOpt THEN
            setSplitItems: splitOpt = 2: DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            IF splitOpt = 0 AND savNumSplitItems THEN
               editMode = savEditMode
               splitStr = savSplitStr
               numSplitItems = savNumSplitItems
               splitOpt = savSplitOpt
               FOR i = 1 TO numSplitItems
                  splitItem(i) = savSplitItem(i)
                  splitDescr(i) = savSplitDescr(i)
               NEXT i
            END IF
            windowNo = 8
            DIALOG END CBHNDL
         END IF
         CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB setSplitItems()
   'create splitStr from split item definitions
   '  1st byte is number of split items
   '  followed by: [catg as WORD, amt AS LONG, descrBytes, descr] for each item
   LOCAL i AS LONG, s AS STRING
   s = CHR$(numSplitItems)
   FOR i = 1 TO numSplitItems 
      s = s + MKWRD$(splitItem(i).catg)+ MKL$(splitItem(i).amt)
      s = s + CHR$(LEN(splitDescr(i))) + splitDescr(i)
   NEXT i
   splitStr = s
END SUB

SUB getSplitItems()
   'divide splitStr into separate split item definitions 
   LOCAL i AS LONG, n AS LONG, s AS STRING
   s = splitStr 
   'IF splitOpt = 0 THEN i = active(selector)
   IF windowNo = 0 THEN i = active(selector)
   IF editMode THEN i = editMode
   IF i THEN s = split(entry(i).catg): splitAmt = entry(i).amt
   IF LEN(s) THEN 
      numSplitItems = ASC(LEFT$(s, 1)): s = MID$(s, 2)
      REDIM splitItem(1:numSplitItems) AS splitData
      REDIM splitDescr(numSplitItems) AS STRING
      FOR i = 1 TO numSplitItems
         splitItem(i).catg = CVWRD(MID$(s, 1, 2))
         splitItem(i).amt = CVL(MID$(s, 3, 4))
         n = ASC(MID$(s, 7, 1)): splitDescr(i) = MID$(s, 8, n)
         s = MID$(s, 8 + n)
      NEXT i
   END IF
END SUB

SUB listSplitItems()
   LOCAL i AS LONG, m AS LONG, n AS LONG, s AS STRING
   LOCAL lptr AS LONG PTR
   DIM tabstops(4) AS LONG
   tabstops(1) = 5
   tabstops(2) = 77
   tabstops(3) = 152
   tabstops(4) = -290
   lptr = VARPTR(tabstops(0))
   CONTROL SEND hSplit, %IDC_SplitItems, %LB_SETTABSTOPS, 5, lptr
   LISTBOX RESET hSplit, %IDC_SplitItems
   FOR i = 1 TO numSplitItems
      n = splitItem(i).catg: m = catg(n).subCatg
      s = catgName(n - m) + $TAB
      IF m THEN s = s + catgName(n)
      s = s + $TAB + splitDescr(i) + $TAB
      IF splitItem(i).amt THEN
         s = s + FORMAT$(splitItem(i).amt/100, "#0.00")
      END IF
      LISTBOX ADD hSplit, %IDC_SplitItems, s
   NEXT i
   SetFocus hSplit 
   LISTBOX SELECT hSplit, %IDC_SplitItems, itemNo
END SUB

SUB deleteSplit(n AS WORD)
   LOCAL i AS LONG, k AS LONG
   ARRAY DELETE split(n): DECR numSplits
   FOR i = 1 TO numEntries 'adjust pointers into split()
      IF entry(i).catg = n THEN entry(i).catg = 0: k = i
      IF entry(i).catg > n THEN DECR entry(i).catg
   NEXT i
   BIT RESET entry(k).flag, 7
END SUB

SUB defineSplitItem()
   LOCAL hDefSplit AS LONG, nStyle AS LONG
   DIALOG NEW hDlg, " Define Split Item", 20, 60, 180, 125, %WS_SYSMENU TO hdefSplit
   CONTROL ADD LABEL, hDefSplit, -1, "Amount:", 5, 5, 40, 10
   CONTROL ADD LABEL, hDefSplit, -1, "Category:", 5, 20, 40, 10
   CONTROL ADD LABEL, hDefSplit, -1, "Subcategory:", 5, 35, 40, 10
   CONTROL ADD LABEL, hDefSplit, -1, "Description:", 5, 50, 40, 10
   nStyle = %CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL
   CONTROL ADD TEXTBOX, hDefSplit, %IDC_SplitAmt, "", 50, 5, 70, 12
   CONTROL ADD COMBOBOX, hDefSplit, %IDC_SplitCatg, , 50, 20, 120, 60, nStyle
   CONTROL ADD COMBOBOX, hDefSplit, %IDC_SplitSubcatg, , 50, 35, 120, 60, nStyle
   CONTROL ADD TEXTBOX, hDefSplit, %IDC_SplitDescr, "", 50, 50, 120, 12
   CONTROL ADD BUTTON, hDefSplit, %IDC_SplitItemOk, "Ok", 40, 80, 45, 20
   CONTROL ADD BUTTON, hDefSplit, %IDCANCEL, "Cancel", 90, 80, 45, 20
   DIALOG SHOW MODAL hDefSplit, CALL defineSplitItemProc
   CONTROL SET FOCUS hSplit, %IDC_SplitAmt
END SUB

CALLBACK FUNCTION defineSplitItemProc()
   LOCAL i AS LONG, j AS LONG, m AS LONG, n AS LONG
   LOCAL sz1 AS ASCIIZ*64, sz2 AS ASCIIZ*64, s AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL GET TEXT hDlg, %IDC_AddDep TO s
         IF LEN(s) THEN n = 1 
         resetCatgList n, CBHNDL, %IDC_SplitCatg
         IF editItem THEN
            itemNo = editItem
            i = splitItem(itemNo).catg
            m = catg(i).subcatg: n = i
            IF m THEN
               n = i - m: m = i: sz1 = catgName(n): sz2 = catgName(i)
               resetSubcatgList n, CBHNDL, %IDC_SplitSubcatg
               CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz1) TO j
               COMBOBOX SELECT CBHNDL, %IDC_SplitCatg, j + 1
               CONTROL SEND CBHNDL, %IDC_SplitSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz2) TO j
               COMBOBOX SELECT CBHNDL, %IDC_SplitSubcatg, j + 1
            ELSE
               sz1 = catgName(i)
               CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz1) TO j
               COMBOBOX SELECT CBHNDL, %IDC_SplitCatg, j + 1
            END IF
            CONTROL SET TEXT CBHNDL, %IDC_SplitDescr, splitDescr(itemNo)
            s = FORMAT$(splitItem(itemNo).amt/100, "#0.00")
            CONTROL SET TEXT CBHNDL, %IDC_SplitAmt, s
         ELSE
            n = splitAmt 
            FOR i = 1 TO numSplitItems
               n = n - splitItem(i).amt
            NEXT i
            s = FORMAT$(n/100, "#0.00")
            CONTROL SET TEXT CBHNDL, %IDC_SplitAmt, s
         END IF
         windowNo = 50: 
         hWindow = CBHNDL: enterFieldID = %IDC_SplitItemOk
      CASE %WM_COMMAND
         IF CBCTL = %IDC_SplitSubcatg AND CBCTLMSG = %CBN_SETFOCUS THEN
            CONTROL GET TEXT CBHNDL, %IDC_SplitCatg TO sz1
            CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz1) TO j
            IF j >= 0 THEN
               CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_GETITEMDATA, j, 0 TO n
               resetSubcatgList n, CBHNDL, %IDC_SplitSubcatg
            END IF
         ELSEIF CBCTL = %IDC_SplitAmt THEN
            IF CBCTLMSG = %EN_SETFOCUS THEN m = 0 ELSE m = -1
            CONTROL SEND CBHNDL, %IDC_SplitAmt, %EM_SETSEL, m, -1
         ELSEIF CBCTL = %IDC_SplitItemOk THEN
            itemNo = editItem
            IF editItem = 0 THEN 'new item
               INCR numSplitItems: itemNo = numSplitItems
               REDIM PRESERVE splitItem(1:numSplitItems) AS splitData
               REDIM PRESERVE splitDescr(numSplitItems) AS STRING
            END IF
            CONTROL GET TEXT CBHNDL, %IDC_SplitCatg TO sz1
            CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz1) TO j
            IF j >= 0 THEN
               CONTROL SEND CBHNDL, %IDC_SplitCatg, %CB_GETITEMDATA, j, 0 TO n
            END IF
            CONTROL GET TEXT CBHNDL, %IDC_SplitSubcatg TO sz2
            CONTROL SEND CBHNDL, %IDC_SplitSubcatg, %CB_FINDSTRINGEXACT, -1, VARPTR(sz2) TO j
            splitItem(itemNo).catg = n + j + 1
            CONTROL GET TEXT CBHNDL, %IDC_SplitDescr TO s
            splitDescr(itemNo) = s
            CONTROL GET TEXT CBHNDL, %IDC_SplitAmt TO s
            splitItem(itemNo).amt = VAL(s) * 100
            DIALOG END CBHNDL
         ELSEIF CBCTL = %IDCANCEL THEN
            DIALOG END CBHNDL
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB groupChg()
   LOCAL hGrpEdit AS LONG, s AS STRING
   DIALOG NEW hDlg,"Group Edit",,, 180, 100, %WS_SYSMENU TO hGrpEdit
   CONTROL ADD CHECKBOX, hGrpEdit, %IDC_delMemos, "Remove memos", 10, 40, 70, 12
   CONTROL ADD CHECKBOX, hGrpEdit, %IDC_delCatgs, "Remove catgs", 10, 55, 70, 12
   CONTROL ADD BUTTON, hGrpEdit, %IDOK, "OK", 110, 40, 50, 30, %BS_DEFAULT
   DIALOG SHOW MODAL hGrpEdit, CALL groupChgProc
END SUB

CALLBACK FUNCTION groupChgProc()
   LOCAL i AS LONG, j AS LONG, k AS LONG, m AS LONG, n AS LONG
   LOCAL s AS STRING, ti AS STRING, sz AS ASCIIZ*32, x AS LONG 
   DIM temp(7) AS STRING
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         s = "- Make specified changes to all selected entries" + $CRLF
         CONTROL GET TEXT hDlg, %IDC_AddCkNo TO sz 
         IF LEN(sz) THEN s = s + "- Increment check numbers by specified amount"
         CONTROL ADD LABEL, CBHNDL, -1, s, 10, 10, 170, 30, %SS_NOPREFIX
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN 'perform the group edit now
            FOR i = 0 TO 7
               CONTROL GET TEXT hDlg, %IDC_AddDate + i TO s
               temp(i) = TRIM$(s): IF LEN(temp(i)) THEN j = 1
               IF (i = 3 OR i = 4) AND LEN(temp(i)) THEN k = 1
            NEXT i
            CONTROL GET CHECK CBHNDL, %IDC_delMemos TO m
            CONTROL GET CHECK CBHNDL, %IDC_delCatgs TO n
            ti = "Group Edit"
            IF j + m + n = 0 THEN
               s = "No change has been specified"
               MSGBOX s, %MB_ICONINFORMATION, ti
               DIALOG END CBHNDL: EXIT FUNCTION
            ELSEIF k AND clearedEntry THEN 
               s = "Cannot change amounts for reconciled entries"
               MSGBOX s, %MB_ICONWARNING, ti
               DIALOG END CBHNDL: EXIT FUNCTION
            END IF
            grpChange = 1
            IF m THEN BIT SET grpChange, 1
            IF n THEN BIT SET grpChange, 2
            i = 1: k = VAL(temp(1)) 'ckno field 
            DO UNTIL i > numEntries
               IF entry(i).acct = acctNo AND BIT(entry(i).flag, 2) THEN 'selected
                  getFields i: j = VAL(fields(1))
                  IF k AND j THEN fields(1) = TRIM$(STR$(k + j))
                  FOR j = 0 TO 7
                     IF LEN(temp(j)) AND j <> 1 THEN fields(j) = temp(j)
                     IF j < 6 THEN 
                        CONTROL SET TEXT hDlg, %IDC_AddDate + j, fields(j)
                     ELSE
                        sz = fields(j): x = %IDC_AddDate + j  
                        CONTROL SEND hDlg, x, %CB_FINDSTRINGEXACT, -1, VARPTR(sz) TO m
                        CONTROL SEND hDlg, x, %CB_GETITEMDATA, m, 0 TO n
                        COMBOBOX SELECT hDlg, x, m + 1
                     END IF   
                  NEXT j
                  BIT RESET entry(i).flag, 2: DECR numSelected
                  editMode = i: addEntry: i = 1
               ELSE
                  INCR i
               END IF
            LOOP
            grpChange = 0: editMode = 0: updateAcct: statusLine 1: clearEntry
            DIALOG END CBHNDL
         END IF
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION

SUB printData()
   'print selected entries (or all if none selected)
   LOCAL prnError AS BYTE, charHt AS DOUBLE, tm AS TEXTMETRIC
   LOCAL i AS WORD, j AS LONG, LINES AS INTEGER, linesPerPg AS INTEGER
   LOCAL s AS STRING, n AS LONG, di AS DOCINFO, dpi AS LONG, hPen AS LONG
   LOCAL sz AS ASCIIZ * 1024, t AS SIZEL, hPrnDC AS LONG, pd AS PRINTDLGAPI
   LOCAL title1 AS STRING, title2 AS STRING   
   pd.lStructSize = SIZEOF(pd)
   pd.hWndOwner = hDlg
   pd.nFromPage = 1
   pd.Flags = %PD_RETURNDC OR %PD_NOPAGENUMS OR %PD_HIDEPRINTTOFILE
   IF numSelected THEN pd.Flags = pd.Flags OR %PD_SELECTION 
   IF printDlg(pd) THEN
      DeleteDC hPrnDC: hPrnDC = pd.hdc
   ELSE
      EXIT SUB
   END IF
   IF numSelected = 0 THEN
      FOR i = 1 TO numActive
         BIT SET entry(active(i)).flag, 2
      NEXT i: numSelected = numActive
   END IF
   REDIM vLine(9)
   DATA 100, 270, 500, 1450, 1500, 1800, 2100, 2105, 2500, 2500
   IF hPrnDC = 0 THEN prnError = 1: GOTO WrapUp
   linesPerPg = 50: fontType = "Times New Roman"
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO wrapUp
   IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
   hFont = makeFont(hPrnDC, fontType, 11)
   hOrigFont = SelectObject (hPrnDC, hFont)
   dpi = GetDeviceCaps(hPrnDC, %LOGPIXELSX)
   FOR i = 0 TO 9 'read vert line positions
      vLine(i) = (100 + VAL(READ$(i + 1))) * dpi / 300
   NEXT i
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   sz = SPACE$(100): GetTextExtentPoint32 hPrnDC, sz, 100, t
   blankLen = t.cx/100: printing = 1: LINES = 999
   title1 = "Date           CkNo         Payee"
   title2 = "Pay                 Dep  "
   FOR i = 1 TO numActive
      n = active(i)
      IF BIT(entry(n).flag, 2) THEN
         IF LINES > linesPerPg THEN
            IF  LINES < 999 THEN
               EndPage hPrnDC: StartPage hPrnDC
            END IF
            LINES = 0: j = 2*charHt
            hFont = makeFont(hPrnDC, fontType , 12, "i")
            SelectObject hPrnDC, hFont
            showText hPrnDC, 240*dpi/300, j, title1
            showText hPrnDC, 1800*dpi/300, j, title2
            hPen = CreatePen(%PS_SOLID, 4*dpi/300, 0)
            SelectObject hPrnDC, hPen
            MoveToEx hPrnDC, 160*dpi/300, j+1.2*charHt, BYVAL %NULL
            LineTo hPrnDC, 2250*dpi/300, j+1.2*charHt 
            j = j + 2*charHt
            hFont = makeFont(hPrnDC, fontType , 11)
            SelectObject hPrnDC, hFont
         END IF
         INCR LINES: showLine hPrnDC, i, j
         DECR numSelected: BIT RESET entry(n).flag, 2
         j = j + charHt: IF numSelected = 0 THEN EXIT FOR
      END IF
   NEXT i
   EndPage hPrnDC
   EndDoc hPrnDC
wrapUp:
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   printing = 0
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteObject hPen
END SUB

SUB about()
   LOCAL hAbout AS LONG, s AS STRING
   s = "Check Book for Windows" + $CRLF + $CRLF
   s = s + "Version number " + $verNo + " - Free distribution" + $CRLF
   s = s + "by Charles G. Dietz" + $CRLF + $CRLF
   s = s + "chasdietz@earthlink.net" + $CRLF
   s = s + "http://home.earthlink.net/~chasdietz"
   DIALOG NEW hDlg,"About winPam",,, 190, 100 TO hAbout
   DIALOG SET COLOR hAbout, -1, %LTGRAY
   CONTROL ADD IMAGE, hAbout, -2, "CkBkIcon", 10, 10, 30, 30
   CONTROL ADD LABEL, hAbout, -1, s, 50, 10, 140, 60, %SS_NOPREFIX
   CONTROL SET COLOR hAbout, -1, %BLACK, %LTGRAY
   CONTROL ADD BUTTON, hAbout, %IDOK, "OK", 85, 70, 50, 25, %BS_DEFAULT
   DIALOG SHOW MODAL hAbout, CALL aboutProc
END SUB

CALLBACK FUNCTION aboutProc()
   SELECT CASE CBMSG
      CASE %WM_COMMAND
         DIALOG END CBHNDL
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_MONITORPOWER THEN
            reviveMonitor = 1: SetActiveWindow hDlg
         END IF
   END SELECT
END FUNCTION
